// Copyright 2019 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated code. DO NOT EDIT!

using gax = Google.Api.Gax;
using gaxgrpc = Google.Api.Gax.Grpc;
using pb = Google.Protobuf;
using pbwkt = Google.Protobuf.WellKnownTypes;
using grpccore = Grpc.Core;
using sys = System;
using sc = System.Collections;
using scg = System.Collections.Generic;
using sco = System.Collections.ObjectModel;
using st = System.Threading;
using stt = System.Threading.Tasks;

namespace Google.Android.OverTheAir.V1
{
    /// <summary>
    /// Settings for a <see cref="OverTheAirServiceClient"/>.
    /// </summary>
    public sealed partial class OverTheAirServiceSettings : gaxgrpc::ServiceSettingsBase
    {
        /// <summary>
        /// Get a new instance of the default <see cref="OverTheAirServiceSettings"/>.
        /// </summary>
        /// <returns>
        /// A new instance of the default <see cref="OverTheAirServiceSettings"/>.
        /// </returns>
        public static OverTheAirServiceSettings GetDefault() => new OverTheAirServiceSettings();

        /// <summary>
        /// Constructs a new <see cref="OverTheAirServiceSettings"/> object with default settings.
        /// </summary>
        public OverTheAirServiceSettings() { }

        private OverTheAirServiceSettings(OverTheAirServiceSettings existing) : base(existing)
        {
            gax::GaxPreconditions.CheckNotNull(existing, nameof(existing));
            GetDeploymentSettings = existing.GetDeploymentSettings;
            ListDeploymentsSettings = existing.ListDeploymentsSettings;
            UpdateDeploymentSettings = existing.UpdateDeploymentSettings;
            GetPackageSettings = existing.GetPackageSettings;
            ListPackagesSettings = existing.ListPackagesSettings;
            DeletePackageSettings = existing.DeletePackageSettings;
            UpdatePackageSettings = existing.UpdatePackageSettings;
            CreateConfigSettings = existing.CreateConfigSettings;
            GetConfigSettings = existing.GetConfigSettings;
            ListConfigsSettings = existing.ListConfigsSettings;
            DeleteConfigSettings = existing.DeleteConfigSettings;
            UpdateConfigSettings = existing.UpdateConfigSettings;
            CreateGroupSettings = existing.CreateGroupSettings;
            GetGroupSettings = existing.GetGroupSettings;
            ListGroupsSettings = existing.ListGroupsSettings;
            DeleteGroupSettings = existing.DeleteGroupSettings;
            UpdateGroupSettings = existing.UpdateGroupSettings;
            DisableGroupsSettings = existing.DisableGroupsSettings;
            EnableGroupsSettings = existing.EnableGroupsSettings;
            CreateGroupMemberSettings = existing.CreateGroupMemberSettings;
            CreateGroupMembersSettings = existing.CreateGroupMembersSettings;
            GetGroupMemberSettings = existing.GetGroupMemberSettings;
            ListGroupMembersSettings = existing.ListGroupMembersSettings;
            DeleteGroupMemberSettings = existing.DeleteGroupMemberSettings;
            DeleteGroupMembersSettings = existing.DeleteGroupMembersSettings;
            GetGroupChartSettings = existing.GetGroupChartSettings;
            ListGroupChartsSettings = existing.ListGroupChartsSettings;
            ListGroupConfigsSettings = existing.ListGroupConfigsSettings;
            UpdateGroupConfigsSettings = existing.UpdateGroupConfigsSettings;
            DisableAllEnabledGroupsOfConfigSettings = existing.DisableAllEnabledGroupsOfConfigSettings;
            ListConfigPackagesSettings = existing.ListConfigPackagesSettings;
            UpdateConfigPackagesSettings = existing.UpdateConfigPackagesSettings;
            ListConfigsUsingPackageSettings = existing.ListConfigsUsingPackageSettings;
            OnCopy(existing);
        }

        partial void OnCopy(OverTheAirServiceSettings existing);

        /// <summary>
        /// The filter specifying which RPC <see cref="grpccore::StatusCode"/>s are eligible for retry
        /// for "Idempotent" <see cref="OverTheAirServiceClient"/> RPC methods.
        /// </summary>
        /// <remarks>
        /// The eligible RPC <see cref="grpccore::StatusCode"/>s for retry for "Idempotent" RPC methods are:
        /// <list type="bullet">
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// </remarks>
        public static sys::Predicate<grpccore::RpcException> IdempotentRetryFilter { get; } =
            gaxgrpc::RetrySettings.FilterForStatusCodes(grpccore::StatusCode.DeadlineExceeded, grpccore::StatusCode.Unavailable);

        /// <summary>
        /// The filter specifying which RPC <see cref="grpccore::StatusCode"/>s are eligible for retry
        /// for "NonIdempotent" <see cref="OverTheAirServiceClient"/> RPC methods.
        /// </summary>
        /// <remarks>
        /// There are no RPC <see cref="grpccore::StatusCode"/>s eligible for retry for "NonIdempotent" RPC methods.
        /// </remarks>
        public static sys::Predicate<grpccore::RpcException> NonIdempotentRetryFilter { get; } =
            gaxgrpc::RetrySettings.FilterForStatusCodes();

        /// <summary>
        /// "Default" retry backoff for <see cref="OverTheAirServiceClient"/> RPC methods.
        /// </summary>
        /// <returns>
        /// The "Default" retry backoff for <see cref="OverTheAirServiceClient"/> RPC methods.
        /// </returns>
        /// <remarks>
        /// The "Default" retry backoff for <see cref="OverTheAirServiceClient"/> RPC methods is defined as:
        /// <list type="bullet">
        /// <item><description>Initial delay: 100 milliseconds</description></item>
        /// <item><description>Maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Delay multiplier: 1.3</description></item>
        /// </list>
        /// </remarks>
        public static gaxgrpc::BackoffSettings GetDefaultRetryBackoff() => new gaxgrpc::BackoffSettings(
            delay: sys::TimeSpan.FromMilliseconds(100),
            maxDelay: sys::TimeSpan.FromMilliseconds(60000),
            delayMultiplier: 1.3
        );

        /// <summary>
        /// "Default" timeout backoff for <see cref="OverTheAirServiceClient"/> RPC methods.
        /// </summary>
        /// <returns>
        /// The "Default" timeout backoff for <see cref="OverTheAirServiceClient"/> RPC methods.
        /// </returns>
        /// <remarks>
        /// The "Default" timeout backoff for <see cref="OverTheAirServiceClient"/> RPC methods is defined as:
        /// <list type="bullet">
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Maximum timeout: 20000 milliseconds</description></item>
        /// </list>
        /// </remarks>
        public static gaxgrpc::BackoffSettings GetDefaultTimeoutBackoff() => new gaxgrpc::BackoffSettings(
            delay: sys::TimeSpan.FromMilliseconds(20000),
            maxDelay: sys::TimeSpan.FromMilliseconds(20000),
            delayMultiplier: 1.0
        );

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.GetDeployment</c> and <c>OverTheAirServiceClient.GetDeploymentAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.GetDeployment</c> and
        /// <c>OverTheAirServiceClient.GetDeploymentAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings GetDeploymentSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.ListDeployments</c> and <c>OverTheAirServiceClient.ListDeploymentsAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.ListDeployments</c> and
        /// <c>OverTheAirServiceClient.ListDeploymentsAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings ListDeploymentsSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.UpdateDeployment</c> and <c>OverTheAirServiceClient.UpdateDeploymentAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.UpdateDeployment</c> and
        /// <c>OverTheAirServiceClient.UpdateDeploymentAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings UpdateDeploymentSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.GetPackage</c> and <c>OverTheAirServiceClient.GetPackageAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.GetPackage</c> and
        /// <c>OverTheAirServiceClient.GetPackageAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings GetPackageSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.ListPackages</c> and <c>OverTheAirServiceClient.ListPackagesAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.ListPackages</c> and
        /// <c>OverTheAirServiceClient.ListPackagesAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings ListPackagesSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.DeletePackage</c> and <c>OverTheAirServiceClient.DeletePackageAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.DeletePackage</c> and
        /// <c>OverTheAirServiceClient.DeletePackageAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings DeletePackageSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.UpdatePackage</c> and <c>OverTheAirServiceClient.UpdatePackageAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.UpdatePackage</c> and
        /// <c>OverTheAirServiceClient.UpdatePackageAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings UpdatePackageSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.CreateConfig</c> and <c>OverTheAirServiceClient.CreateConfigAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.CreateConfig</c> and
        /// <c>OverTheAirServiceClient.CreateConfigAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description>No status codes</description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings CreateConfigSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: NonIdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.GetConfig</c> and <c>OverTheAirServiceClient.GetConfigAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.GetConfig</c> and
        /// <c>OverTheAirServiceClient.GetConfigAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings GetConfigSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.ListConfigs</c> and <c>OverTheAirServiceClient.ListConfigsAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.ListConfigs</c> and
        /// <c>OverTheAirServiceClient.ListConfigsAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings ListConfigsSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.DeleteConfig</c> and <c>OverTheAirServiceClient.DeleteConfigAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.DeleteConfig</c> and
        /// <c>OverTheAirServiceClient.DeleteConfigAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings DeleteConfigSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.UpdateConfig</c> and <c>OverTheAirServiceClient.UpdateConfigAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.UpdateConfig</c> and
        /// <c>OverTheAirServiceClient.UpdateConfigAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings UpdateConfigSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.CreateGroup</c> and <c>OverTheAirServiceClient.CreateGroupAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.CreateGroup</c> and
        /// <c>OverTheAirServiceClient.CreateGroupAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description>No status codes</description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings CreateGroupSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: NonIdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.GetGroup</c> and <c>OverTheAirServiceClient.GetGroupAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.GetGroup</c> and
        /// <c>OverTheAirServiceClient.GetGroupAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings GetGroupSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.ListGroups</c> and <c>OverTheAirServiceClient.ListGroupsAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.ListGroups</c> and
        /// <c>OverTheAirServiceClient.ListGroupsAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings ListGroupsSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.DeleteGroup</c> and <c>OverTheAirServiceClient.DeleteGroupAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.DeleteGroup</c> and
        /// <c>OverTheAirServiceClient.DeleteGroupAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings DeleteGroupSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.UpdateGroup</c> and <c>OverTheAirServiceClient.UpdateGroupAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.UpdateGroup</c> and
        /// <c>OverTheAirServiceClient.UpdateGroupAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings UpdateGroupSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.DisableGroups</c> and <c>OverTheAirServiceClient.DisableGroupsAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.DisableGroups</c> and
        /// <c>OverTheAirServiceClient.DisableGroupsAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description>No status codes</description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings DisableGroupsSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: NonIdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.EnableGroups</c> and <c>OverTheAirServiceClient.EnableGroupsAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.EnableGroups</c> and
        /// <c>OverTheAirServiceClient.EnableGroupsAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description>No status codes</description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings EnableGroupsSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: NonIdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.CreateGroupMember</c> and <c>OverTheAirServiceClient.CreateGroupMemberAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.CreateGroupMember</c> and
        /// <c>OverTheAirServiceClient.CreateGroupMemberAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description>No status codes</description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings CreateGroupMemberSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: NonIdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.CreateGroupMembers</c> and <c>OverTheAirServiceClient.CreateGroupMembersAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.CreateGroupMembers</c> and
        /// <c>OverTheAirServiceClient.CreateGroupMembersAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description>No status codes</description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings CreateGroupMembersSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: NonIdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.GetGroupMember</c> and <c>OverTheAirServiceClient.GetGroupMemberAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.GetGroupMember</c> and
        /// <c>OverTheAirServiceClient.GetGroupMemberAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings GetGroupMemberSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.ListGroupMembers</c> and <c>OverTheAirServiceClient.ListGroupMembersAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.ListGroupMembers</c> and
        /// <c>OverTheAirServiceClient.ListGroupMembersAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings ListGroupMembersSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.DeleteGroupMember</c> and <c>OverTheAirServiceClient.DeleteGroupMemberAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.DeleteGroupMember</c> and
        /// <c>OverTheAirServiceClient.DeleteGroupMemberAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings DeleteGroupMemberSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.DeleteGroupMembers</c> and <c>OverTheAirServiceClient.DeleteGroupMembersAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.DeleteGroupMembers</c> and
        /// <c>OverTheAirServiceClient.DeleteGroupMembersAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description>No status codes</description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings DeleteGroupMembersSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: NonIdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.GetGroupChart</c> and <c>OverTheAirServiceClient.GetGroupChartAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.GetGroupChart</c> and
        /// <c>OverTheAirServiceClient.GetGroupChartAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings GetGroupChartSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.ListGroupCharts</c> and <c>OverTheAirServiceClient.ListGroupChartsAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.ListGroupCharts</c> and
        /// <c>OverTheAirServiceClient.ListGroupChartsAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings ListGroupChartsSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.ListGroupConfigs</c> and <c>OverTheAirServiceClient.ListGroupConfigsAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.ListGroupConfigs</c> and
        /// <c>OverTheAirServiceClient.ListGroupConfigsAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings ListGroupConfigsSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.UpdateGroupConfigs</c> and <c>OverTheAirServiceClient.UpdateGroupConfigsAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.UpdateGroupConfigs</c> and
        /// <c>OverTheAirServiceClient.UpdateGroupConfigsAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings UpdateGroupConfigsSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.DisableAllEnabledGroupsOfConfig</c> and <c>OverTheAirServiceClient.DisableAllEnabledGroupsOfConfigAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.DisableAllEnabledGroupsOfConfig</c> and
        /// <c>OverTheAirServiceClient.DisableAllEnabledGroupsOfConfigAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description>No status codes</description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings DisableAllEnabledGroupsOfConfigSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: NonIdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.ListConfigPackages</c> and <c>OverTheAirServiceClient.ListConfigPackagesAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.ListConfigPackages</c> and
        /// <c>OverTheAirServiceClient.ListConfigPackagesAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings ListConfigPackagesSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.UpdateConfigPackages</c> and <c>OverTheAirServiceClient.UpdateConfigPackagesAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.UpdateConfigPackages</c> and
        /// <c>OverTheAirServiceClient.UpdateConfigPackagesAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings UpdateConfigPackagesSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// <see cref="gaxgrpc::CallSettings"/> for synchronous and asynchronous calls to
        /// <c>OverTheAirServiceClient.ListConfigsUsingPackage</c> and <c>OverTheAirServiceClient.ListConfigsUsingPackageAsync</c>.
        /// </summary>
        /// <remarks>
        /// The default <c>OverTheAirServiceClient.ListConfigsUsingPackage</c> and
        /// <c>OverTheAirServiceClient.ListConfigsUsingPackageAsync</c> <see cref="gaxgrpc::RetrySettings"/> are:
        /// <list type="bullet">
        /// <item><description>Initial retry delay: 100 milliseconds</description></item>
        /// <item><description>Retry delay multiplier: 1.3</description></item>
        /// <item><description>Retry maximum delay: 60000 milliseconds</description></item>
        /// <item><description>Initial timeout: 20000 milliseconds</description></item>
        /// <item><description>Timeout multiplier: 1.0</description></item>
        /// <item><description>Timeout maximum delay: 20000 milliseconds</description></item>
        /// </list>
        /// Retry will be attempted on the following response status codes:
        /// <list>
        /// <item><description><see cref="grpccore::StatusCode.DeadlineExceeded"/></description></item>
        /// <item><description><see cref="grpccore::StatusCode.Unavailable"/></description></item>
        /// </list>
        /// Default RPC expiration is 600000 milliseconds.
        /// </remarks>
        public gaxgrpc::CallSettings ListConfigsUsingPackageSettings { get; set; } = gaxgrpc::CallSettings.FromCallTiming(
            gaxgrpc::CallTiming.FromRetry(new gaxgrpc::RetrySettings(
                retryBackoff: GetDefaultRetryBackoff(),
                timeoutBackoff: GetDefaultTimeoutBackoff(),
                totalExpiration: gax::Expiration.FromTimeout(sys::TimeSpan.FromMilliseconds(600000)),
                retryFilter: IdempotentRetryFilter
            )));

        /// <summary>
        /// Creates a deep clone of this object, with all the same property values.
        /// </summary>
        /// <returns>A deep clone of this <see cref="OverTheAirServiceSettings"/> object.</returns>
        public OverTheAirServiceSettings Clone() => new OverTheAirServiceSettings(this);
    }

    /// <summary>
    /// OverTheAirService client wrapper, for convenient use.
    /// </summary>
    public abstract partial class OverTheAirServiceClient
    {
        /// <summary>
        /// The default endpoint for the OverTheAirService service, which is a host of "androidovertheair.googleapis.com" and a port of 443.
        /// </summary>
        public static gaxgrpc::ServiceEndpoint DefaultEndpoint { get; } = new gaxgrpc::ServiceEndpoint("androidovertheair.googleapis.com", 443);

        /// <summary>
        /// The default OverTheAirService scopes.
        /// </summary>
        /// <remarks>
        /// The default OverTheAirService scopes are:
        /// <list type="bullet">
        /// <item><description>"https://www.googleapis.com/auth/android_partner_over_the_air"</description></item>
        /// <item><description>"https://www.googleapis.com/auth/userinfo.email"</description></item>
        /// </list>
        /// </remarks>
        public static scg::IReadOnlyList<string> DefaultScopes { get; } = new sco::ReadOnlyCollection<string>(new string[] {
            "https://www.googleapis.com/auth/android_partner_over_the_air",
            "https://www.googleapis.com/auth/userinfo.email",
        });

        private static readonly gaxgrpc::ChannelPool s_channelPool = new gaxgrpc::ChannelPool(DefaultScopes);

        /// <summary>
        /// Asynchronously creates a <see cref="OverTheAirServiceClient"/>, applying defaults for all unspecified settings,
        /// and creating a channel connecting to the given endpoint with application default credentials where
        /// necessary. See the example for how to use custom credentials.
        /// </summary>
        /// <example>
        /// This sample shows how to create a client using default credentials:
        /// <code>
        /// using Google.Android.OverTheAir.V1;
        /// ...
        /// // When running on Google Cloud Platform this will use the project Compute Credential.
        /// // Or set the GOOGLE_APPLICATION_CREDENTIALS environment variable to the path of a JSON
        /// // credential file to use that credential.
        /// OverTheAirServiceClient client = await OverTheAirServiceClient.CreateAsync();
        /// </code>
        /// This sample shows how to create a client using credentials loaded from a JSON file:
        /// <code>
        /// using Google.Android.OverTheAir.V1;
        /// using Google.Apis.Auth.OAuth2;
        /// using Grpc.Auth;
        /// using Grpc.Core;
        /// ...
        /// GoogleCredential cred = GoogleCredential.FromFile("/path/to/credentials.json");
        /// Channel channel = new Channel(
        ///     OverTheAirServiceClient.DefaultEndpoint.Host, OverTheAirServiceClient.DefaultEndpoint.Port, cred.ToChannelCredentials());
        /// OverTheAirServiceClient client = OverTheAirServiceClient.Create(channel);
        /// ...
        /// // Shutdown the channel when it is no longer required.
        /// await channel.ShutdownAsync();
        /// </code>
        /// </example>
        /// <param name="endpoint">Optional <see cref="gaxgrpc::ServiceEndpoint"/>.</param>
        /// <param name="settings">Optional <see cref="OverTheAirServiceSettings"/>.</param>
        /// <returns>The task representing the created <see cref="OverTheAirServiceClient"/>.</returns>
        public static async stt::Task<OverTheAirServiceClient> CreateAsync(gaxgrpc::ServiceEndpoint endpoint = null, OverTheAirServiceSettings settings = null)
        {
            grpccore::Channel channel = await s_channelPool.GetChannelAsync(endpoint ?? DefaultEndpoint).ConfigureAwait(false);
            return Create(channel, settings);
        }

        /// <summary>
        /// Synchronously creates a <see cref="OverTheAirServiceClient"/>, applying defaults for all unspecified settings,
        /// and creating a channel connecting to the given endpoint with application default credentials where
        /// necessary. See the example for how to use custom credentials.
        /// </summary>
        /// <example>
        /// This sample shows how to create a client using default credentials:
        /// <code>
        /// using Google.Android.OverTheAir.V1;
        /// ...
        /// // When running on Google Cloud Platform this will use the project Compute Credential.
        /// // Or set the GOOGLE_APPLICATION_CREDENTIALS environment variable to the path of a JSON
        /// // credential file to use that credential.
        /// OverTheAirServiceClient client = OverTheAirServiceClient.Create();
        /// </code>
        /// This sample shows how to create a client using credentials loaded from a JSON file:
        /// <code>
        /// using Google.Android.OverTheAir.V1;
        /// using Google.Apis.Auth.OAuth2;
        /// using Grpc.Auth;
        /// using Grpc.Core;
        /// ...
        /// GoogleCredential cred = GoogleCredential.FromFile("/path/to/credentials.json");
        /// Channel channel = new Channel(
        ///     OverTheAirServiceClient.DefaultEndpoint.Host, OverTheAirServiceClient.DefaultEndpoint.Port, cred.ToChannelCredentials());
        /// OverTheAirServiceClient client = OverTheAirServiceClient.Create(channel);
        /// ...
        /// // Shutdown the channel when it is no longer required.
        /// channel.ShutdownAsync().Wait();
        /// </code>
        /// </example>
        /// <param name="endpoint">Optional <see cref="gaxgrpc::ServiceEndpoint"/>.</param>
        /// <param name="settings">Optional <see cref="OverTheAirServiceSettings"/>.</param>
        /// <returns>The created <see cref="OverTheAirServiceClient"/>.</returns>
        public static OverTheAirServiceClient Create(gaxgrpc::ServiceEndpoint endpoint = null, OverTheAirServiceSettings settings = null)
        {
            grpccore::Channel channel = s_channelPool.GetChannel(endpoint ?? DefaultEndpoint);
            return Create(channel, settings);
        }

        /// <summary>
        /// Creates a <see cref="OverTheAirServiceClient"/> which uses the specified channel for remote operations.
        /// </summary>
        /// <param name="channel">The <see cref="grpccore::Channel"/> for remote operations. Must not be null.</param>
        /// <param name="settings">Optional <see cref="OverTheAirServiceSettings"/>.</param>
        /// <returns>The created <see cref="OverTheAirServiceClient"/>.</returns>
        public static OverTheAirServiceClient Create(grpccore::Channel channel, OverTheAirServiceSettings settings = null)
        {
            gax::GaxPreconditions.CheckNotNull(channel, nameof(channel));
            return Create(new grpccore::DefaultCallInvoker(channel), settings);
        }

        /// <summary>
        /// Creates a <see cref="OverTheAirServiceClient"/> which uses the specified call invoker for remote operations.
        /// </summary>
        /// <param name="callInvoker">The <see cref="grpccore::CallInvoker"/> for remote operations. Must not be null.</param>
        /// <param name="settings">Optional <see cref="OverTheAirServiceSettings"/>.</param>
        /// <returns>The created <see cref="OverTheAirServiceClient"/>.</returns>
        public static OverTheAirServiceClient Create(grpccore::CallInvoker callInvoker, OverTheAirServiceSettings settings = null)
        {
            gax::GaxPreconditions.CheckNotNull(callInvoker, nameof(callInvoker));
            grpccore::Interceptors.Interceptor interceptor = settings?.Interceptor;
            if (interceptor != null)
            {
                callInvoker = grpccore::Interceptors.CallInvokerExtensions.Intercept(callInvoker, interceptor);
            }
            OverTheAirService.OverTheAirServiceClient grpcClient = new OverTheAirService.OverTheAirServiceClient(callInvoker);
            return new OverTheAirServiceClientImpl(grpcClient, settings);
        }

        /// <summary>
        /// Shuts down any channels automatically created by <see cref="Create(gaxgrpc::ServiceEndpoint, OverTheAirServiceSettings)"/>
        /// and <see cref="CreateAsync(gaxgrpc::ServiceEndpoint, OverTheAirServiceSettings)"/>. Channels which weren't automatically
        /// created are not affected.
        /// </summary>
        /// <remarks>After calling this method, further calls to <see cref="Create(gaxgrpc::ServiceEndpoint, OverTheAirServiceSettings)"/>
        /// and <see cref="CreateAsync(gaxgrpc::ServiceEndpoint, OverTheAirServiceSettings)"/> will create new channels, which could
        /// in turn be shut down by another call to this method.</remarks>
        /// <returns>A task representing the asynchronous shutdown operation.</returns>
        public static stt::Task ShutdownDefaultChannelsAsync() => s_channelPool.ShutdownChannelsAsync();

        /// <summary>
        /// The underlying gRPC OverTheAirService client.
        /// </summary>
        public virtual OverTheAirService.OverTheAirServiceClient GrpcClient
        {
            get { throw new sys::NotImplementedException(); }
        }

        /// <summary>
        /// Gets a [Deployment][google.android.overtheair.v1.Deployment].
        /// Returns `NOT_FOUND` if the deployment does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of the deployment
        /// should be returned.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Deployment> GetDeploymentAsync(
            string name,
            View? view,
            gaxgrpc::CallSettings callSettings = null) => GetDeploymentAsync(
                new GetDeploymentRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    View = view ?? View.Basic, // Optional
                },
                callSettings);

        /// <summary>
        /// Gets a [Deployment][google.android.overtheair.v1.Deployment].
        /// Returns `NOT_FOUND` if the deployment does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of the deployment
        /// should be returned.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Deployment> GetDeploymentAsync(
            string name,
            View? view,
            st::CancellationToken cancellationToken) => GetDeploymentAsync(
                name,
                view,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Gets a [Deployment][google.android.overtheair.v1.Deployment].
        /// Returns `NOT_FOUND` if the deployment does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of the deployment
        /// should be returned.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual Deployment GetDeployment(
            string name,
            View? view,
            gaxgrpc::CallSettings callSettings = null) => GetDeployment(
                new GetDeploymentRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    View = view ?? View.Basic, // Optional
                },
                callSettings);

        /// <summary>
        /// Gets a [Deployment][google.android.overtheair.v1.Deployment].
        /// Returns `NOT_FOUND` if the deployment does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Deployment> GetDeploymentAsync(
            GetDeploymentRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Gets a [Deployment][google.android.overtheair.v1.Deployment].
        /// Returns `NOT_FOUND` if the deployment does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Deployment> GetDeploymentAsync(
            GetDeploymentRequest request,
            st::CancellationToken cancellationToken) => GetDeploymentAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Gets a [Deployment][google.android.overtheair.v1.Deployment].
        /// Returns `NOT_FOUND` if the deployment does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual Deployment GetDeployment(
            GetDeploymentRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Lists [deployments][google.android.overtheair.v1.Deployment].
        /// </summary>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of each deployment
        /// should be returned.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListDeploymentsResponse> ListDeploymentsAsync(
            View? view,
            gaxgrpc::CallSettings callSettings = null) => ListDeploymentsAsync(
                new ListDeploymentsRequest
                {
                    View = view ?? View.Basic, // Optional
                },
                callSettings);

        /// <summary>
        /// Lists [deployments][google.android.overtheair.v1.Deployment].
        /// </summary>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of each deployment
        /// should be returned.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListDeploymentsResponse> ListDeploymentsAsync(
            View? view,
            st::CancellationToken cancellationToken) => ListDeploymentsAsync(
                view,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Lists [deployments][google.android.overtheair.v1.Deployment].
        /// </summary>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of each deployment
        /// should be returned.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual ListDeploymentsResponse ListDeployments(
            View? view,
            gaxgrpc::CallSettings callSettings = null) => ListDeployments(
                new ListDeploymentsRequest
                {
                    View = view ?? View.Basic, // Optional
                },
                callSettings);

        /// <summary>
        /// Lists [deployments][google.android.overtheair.v1.Deployment].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListDeploymentsResponse> ListDeploymentsAsync(
            ListDeploymentsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Lists [deployments][google.android.overtheair.v1.Deployment].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListDeploymentsResponse> ListDeploymentsAsync(
            ListDeploymentsRequest request,
            st::CancellationToken cancellationToken) => ListDeploymentsAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Lists [deployments][google.android.overtheair.v1.Deployment].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual ListDeploymentsResponse ListDeployments(
            ListDeploymentsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Updates a [deployment][google.android.overtheair.v1.Deployment].
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x"
        /// </param>
        /// <param name="deployment">
        /// Required. Only the deployment description can be updated.
        /// </param>
        /// <param name="versionTag">
        /// Required. The deployment to be updated should match this version.
        /// If another client updates the existing instance concurrently, this
        /// update operation will fail.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Deployment> UpdateDeploymentAsync(
            string name,
            Deployment deployment,
            VersionTag versionTag,
            gaxgrpc::CallSettings callSettings = null) => UpdateDeploymentAsync(
                new UpdateDeploymentRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    Deployment = gax::GaxPreconditions.CheckNotNull(deployment, nameof(deployment)),
                    VersionTag = gax::GaxPreconditions.CheckNotNull(versionTag, nameof(versionTag)),
                },
                callSettings);

        /// <summary>
        /// Updates a [deployment][google.android.overtheair.v1.Deployment].
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x"
        /// </param>
        /// <param name="deployment">
        /// Required. Only the deployment description can be updated.
        /// </param>
        /// <param name="versionTag">
        /// Required. The deployment to be updated should match this version.
        /// If another client updates the existing instance concurrently, this
        /// update operation will fail.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Deployment> UpdateDeploymentAsync(
            string name,
            Deployment deployment,
            VersionTag versionTag,
            st::CancellationToken cancellationToken) => UpdateDeploymentAsync(
                name,
                deployment,
                versionTag,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Updates a [deployment][google.android.overtheair.v1.Deployment].
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x"
        /// </param>
        /// <param name="deployment">
        /// Required. Only the deployment description can be updated.
        /// </param>
        /// <param name="versionTag">
        /// Required. The deployment to be updated should match this version.
        /// If another client updates the existing instance concurrently, this
        /// update operation will fail.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual Deployment UpdateDeployment(
            string name,
            Deployment deployment,
            VersionTag versionTag,
            gaxgrpc::CallSettings callSettings = null) => UpdateDeployment(
                new UpdateDeploymentRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    Deployment = gax::GaxPreconditions.CheckNotNull(deployment, nameof(deployment)),
                    VersionTag = gax::GaxPreconditions.CheckNotNull(versionTag, nameof(versionTag)),
                },
                callSettings);

        /// <summary>
        /// Updates a [deployment][google.android.overtheair.v1.Deployment].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Deployment> UpdateDeploymentAsync(
            UpdateDeploymentRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Updates a [deployment][google.android.overtheair.v1.Deployment].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Deployment> UpdateDeploymentAsync(
            UpdateDeploymentRequest request,
            st::CancellationToken cancellationToken) => UpdateDeploymentAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Updates a [deployment][google.android.overtheair.v1.Deployment].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual Deployment UpdateDeployment(
            UpdateDeploymentRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Gets a [package][google.android.overtheair.v1.Package].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/packages/package_a"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of the package
        /// should be returned.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Package> GetPackageAsync(
            string name,
            View? view,
            gaxgrpc::CallSettings callSettings = null) => GetPackageAsync(
                new GetPackageRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    View = view ?? View.Basic, // Optional
                },
                callSettings);

        /// <summary>
        /// Gets a [package][google.android.overtheair.v1.Package].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/packages/package_a"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of the package
        /// should be returned.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Package> GetPackageAsync(
            string name,
            View? view,
            st::CancellationToken cancellationToken) => GetPackageAsync(
                name,
                view,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Gets a [package][google.android.overtheair.v1.Package].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/packages/package_a"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of the package
        /// should be returned.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual Package GetPackage(
            string name,
            View? view,
            gaxgrpc::CallSettings callSettings = null) => GetPackage(
                new GetPackageRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    View = view ?? View.Basic, // Optional
                },
                callSettings);

        /// <summary>
        /// Gets a [package][google.android.overtheair.v1.Package].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Package> GetPackageAsync(
            GetPackageRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Gets a [package][google.android.overtheair.v1.Package].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Package> GetPackageAsync(
            GetPackageRequest request,
            st::CancellationToken cancellationToken) => GetPackageAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Gets a [package][google.android.overtheair.v1.Package].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual Package GetPackage(
            GetPackageRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Lists [packages][google.android.overtheair.v1.Package].
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of each package
        /// should be returned.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListPackagesResponse> ListPackagesAsync(
            string name,
            View? view,
            gaxgrpc::CallSettings callSettings = null) => ListPackagesAsync(
                new ListPackagesRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    View = view ?? View.Basic, // Optional
                },
                callSettings);

        /// <summary>
        /// Lists [packages][google.android.overtheair.v1.Package].
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of each package
        /// should be returned.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListPackagesResponse> ListPackagesAsync(
            string name,
            View? view,
            st::CancellationToken cancellationToken) => ListPackagesAsync(
                name,
                view,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Lists [packages][google.android.overtheair.v1.Package].
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of each package
        /// should be returned.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual ListPackagesResponse ListPackages(
            string name,
            View? view,
            gaxgrpc::CallSettings callSettings = null) => ListPackages(
                new ListPackagesRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    View = view ?? View.Basic, // Optional
                },
                callSettings);

        /// <summary>
        /// Lists [packages][google.android.overtheair.v1.Package].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListPackagesResponse> ListPackagesAsync(
            ListPackagesRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Lists [packages][google.android.overtheair.v1.Package].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListPackagesResponse> ListPackagesAsync(
            ListPackagesRequest request,
            st::CancellationToken cancellationToken) => ListPackagesAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Lists [packages][google.android.overtheair.v1.Package].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual ListPackagesResponse ListPackages(
            ListPackagesRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Deletes a [package][google.android.overtheair.v1.Package].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/packages/package_a"
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DeletePackageResponse> DeletePackageAsync(
            string name,
            gaxgrpc::CallSettings callSettings = null) => DeletePackageAsync(
                new DeletePackageRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                },
                callSettings);

        /// <summary>
        /// Deletes a [package][google.android.overtheair.v1.Package].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/packages/package_a"
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DeletePackageResponse> DeletePackageAsync(
            string name,
            st::CancellationToken cancellationToken) => DeletePackageAsync(
                name,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Deletes a [package][google.android.overtheair.v1.Package].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/packages/package_a"
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual DeletePackageResponse DeletePackage(
            string name,
            gaxgrpc::CallSettings callSettings = null) => DeletePackage(
                new DeletePackageRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                },
                callSettings);

        /// <summary>
        /// Deletes a [package][google.android.overtheair.v1.Package].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DeletePackageResponse> DeletePackageAsync(
            DeletePackageRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Deletes a [package][google.android.overtheair.v1.Package].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DeletePackageResponse> DeletePackageAsync(
            DeletePackageRequest request,
            st::CancellationToken cancellationToken) => DeletePackageAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Deletes a [package][google.android.overtheair.v1.Package].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual DeletePackageResponse DeletePackage(
            DeletePackageRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Updates a [package][google.android.overtheair.v1.Package].
        /// Returns `INVALID_ARGUMENT` if any field other than title is modified.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/packages/package_a"
        /// </param>
        /// <param name="packageObj">
        /// Required. The [Package][google.android.overtheair.v1.Package] to update.
        /// </param>
        /// <param name="versionTag">
        /// Required. The package to be updated should match this version.
        /// If another client updates the existing config concurrently, the
        /// update operation will fail.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Package> UpdatePackageAsync(
            string name,
            Package packageObj,
            VersionTag versionTag,
            gaxgrpc::CallSettings callSettings = null) => UpdatePackageAsync(
                new UpdatePackageRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    PackageObj = gax::GaxPreconditions.CheckNotNull(packageObj, nameof(packageObj)),
                    VersionTag = gax::GaxPreconditions.CheckNotNull(versionTag, nameof(versionTag)),
                },
                callSettings);

        /// <summary>
        /// Updates a [package][google.android.overtheair.v1.Package].
        /// Returns `INVALID_ARGUMENT` if any field other than title is modified.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/packages/package_a"
        /// </param>
        /// <param name="packageObj">
        /// Required. The [Package][google.android.overtheair.v1.Package] to update.
        /// </param>
        /// <param name="versionTag">
        /// Required. The package to be updated should match this version.
        /// If another client updates the existing config concurrently, the
        /// update operation will fail.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Package> UpdatePackageAsync(
            string name,
            Package packageObj,
            VersionTag versionTag,
            st::CancellationToken cancellationToken) => UpdatePackageAsync(
                name,
                packageObj,
                versionTag,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Updates a [package][google.android.overtheair.v1.Package].
        /// Returns `INVALID_ARGUMENT` if any field other than title is modified.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/packages/package_a"
        /// </param>
        /// <param name="packageObj">
        /// Required. The [Package][google.android.overtheair.v1.Package] to update.
        /// </param>
        /// <param name="versionTag">
        /// Required. The package to be updated should match this version.
        /// If another client updates the existing config concurrently, the
        /// update operation will fail.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual Package UpdatePackage(
            string name,
            Package packageObj,
            VersionTag versionTag,
            gaxgrpc::CallSettings callSettings = null) => UpdatePackage(
                new UpdatePackageRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    PackageObj = gax::GaxPreconditions.CheckNotNull(packageObj, nameof(packageObj)),
                    VersionTag = gax::GaxPreconditions.CheckNotNull(versionTag, nameof(versionTag)),
                },
                callSettings);

        /// <summary>
        /// Updates a [package][google.android.overtheair.v1.Package].
        /// Returns `INVALID_ARGUMENT` if any field other than title is modified.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Package> UpdatePackageAsync(
            UpdatePackageRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Updates a [package][google.android.overtheair.v1.Package].
        /// Returns `INVALID_ARGUMENT` if any field other than title is modified.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Package> UpdatePackageAsync(
            UpdatePackageRequest request,
            st::CancellationToken cancellationToken) => UpdatePackageAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Updates a [package][google.android.overtheair.v1.Package].
        /// Returns `INVALID_ARGUMENT` if any field other than title is modified.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual Package UpdatePackage(
            UpdatePackageRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Creates a config, and returns the new
        /// [Config][google.android.overtheair.v1.Config].
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x"
        /// </param>
        /// <param name="config">
        /// Required. The [Config][google.android.overtheair.v1.Config] to create.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Config> CreateConfigAsync(
            string name,
            Config config,
            gaxgrpc::CallSettings callSettings = null) => CreateConfigAsync(
                new CreateConfigRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    Config = gax::GaxPreconditions.CheckNotNull(config, nameof(config)),
                },
                callSettings);

        /// <summary>
        /// Creates a config, and returns the new
        /// [Config][google.android.overtheair.v1.Config].
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x"
        /// </param>
        /// <param name="config">
        /// Required. The [Config][google.android.overtheair.v1.Config] to create.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Config> CreateConfigAsync(
            string name,
            Config config,
            st::CancellationToken cancellationToken) => CreateConfigAsync(
                name,
                config,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Creates a config, and returns the new
        /// [Config][google.android.overtheair.v1.Config].
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x"
        /// </param>
        /// <param name="config">
        /// Required. The [Config][google.android.overtheair.v1.Config] to create.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual Config CreateConfig(
            string name,
            Config config,
            gaxgrpc::CallSettings callSettings = null) => CreateConfig(
                new CreateConfigRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    Config = gax::GaxPreconditions.CheckNotNull(config, nameof(config)),
                },
                callSettings);

        /// <summary>
        /// Creates a config, and returns the new
        /// [Config][google.android.overtheair.v1.Config].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Config> CreateConfigAsync(
            CreateConfigRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Creates a config, and returns the new
        /// [Config][google.android.overtheair.v1.Config].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Config> CreateConfigAsync(
            CreateConfigRequest request,
            st::CancellationToken cancellationToken) => CreateConfigAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Creates a config, and returns the new
        /// [Config][google.android.overtheair.v1.Config].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual Config CreateConfig(
            CreateConfigRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Gets a [config][google.android.overtheair.v1.Config] view.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/configs/config_a"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of the config
        /// should be returned.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Config> GetConfigAsync(
            string name,
            View? view,
            gaxgrpc::CallSettings callSettings = null) => GetConfigAsync(
                new GetConfigRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    View = view ?? View.Basic, // Optional
                },
                callSettings);

        /// <summary>
        /// Gets a [config][google.android.overtheair.v1.Config] view.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/configs/config_a"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of the config
        /// should be returned.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Config> GetConfigAsync(
            string name,
            View? view,
            st::CancellationToken cancellationToken) => GetConfigAsync(
                name,
                view,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Gets a [config][google.android.overtheair.v1.Config] view.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/configs/config_a"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of the config
        /// should be returned.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual Config GetConfig(
            string name,
            View? view,
            gaxgrpc::CallSettings callSettings = null) => GetConfig(
                new GetConfigRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    View = view ?? View.Basic, // Optional
                },
                callSettings);

        /// <summary>
        /// Gets a [config][google.android.overtheair.v1.Config] view.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Config> GetConfigAsync(
            GetConfigRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Gets a [config][google.android.overtheair.v1.Config] view.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Config> GetConfigAsync(
            GetConfigRequest request,
            st::CancellationToken cancellationToken) => GetConfigAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Gets a [config][google.android.overtheair.v1.Config] view.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual Config GetConfig(
            GetConfigRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Lists [configs][google.android.overtheair.v1.Config] of a deployment.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of each config
        /// should be returned.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListConfigsResponse> ListConfigsAsync(
            string name,
            View? view,
            gaxgrpc::CallSettings callSettings = null) => ListConfigsAsync(
                new ListConfigsRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    View = view ?? View.Basic, // Optional
                },
                callSettings);

        /// <summary>
        /// Lists [configs][google.android.overtheair.v1.Config] of a deployment.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of each config
        /// should be returned.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListConfigsResponse> ListConfigsAsync(
            string name,
            View? view,
            st::CancellationToken cancellationToken) => ListConfigsAsync(
                name,
                view,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Lists [configs][google.android.overtheair.v1.Config] of a deployment.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of each config
        /// should be returned.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual ListConfigsResponse ListConfigs(
            string name,
            View? view,
            gaxgrpc::CallSettings callSettings = null) => ListConfigs(
                new ListConfigsRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    View = view ?? View.Basic, // Optional
                },
                callSettings);

        /// <summary>
        /// Lists [configs][google.android.overtheair.v1.Config] of a deployment.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListConfigsResponse> ListConfigsAsync(
            ListConfigsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Lists [configs][google.android.overtheair.v1.Config] of a deployment.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListConfigsResponse> ListConfigsAsync(
            ListConfigsRequest request,
            st::CancellationToken cancellationToken) => ListConfigsAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Lists [configs][google.android.overtheair.v1.Config] of a deployment.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual ListConfigsResponse ListConfigs(
            ListConfigsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Deletes a [config][google.android.overtheair.v1.Config].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/configs/config_a"
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DeleteConfigResponse> DeleteConfigAsync(
            string name,
            gaxgrpc::CallSettings callSettings = null) => DeleteConfigAsync(
                new DeleteConfigRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                },
                callSettings);

        /// <summary>
        /// Deletes a [config][google.android.overtheair.v1.Config].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/configs/config_a"
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DeleteConfigResponse> DeleteConfigAsync(
            string name,
            st::CancellationToken cancellationToken) => DeleteConfigAsync(
                name,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Deletes a [config][google.android.overtheair.v1.Config].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/configs/config_a"
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual DeleteConfigResponse DeleteConfig(
            string name,
            gaxgrpc::CallSettings callSettings = null) => DeleteConfig(
                new DeleteConfigRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                },
                callSettings);

        /// <summary>
        /// Deletes a [config][google.android.overtheair.v1.Config].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DeleteConfigResponse> DeleteConfigAsync(
            DeleteConfigRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Deletes a [config][google.android.overtheair.v1.Config].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DeleteConfigResponse> DeleteConfigAsync(
            DeleteConfigRequest request,
            st::CancellationToken cancellationToken) => DeleteConfigAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Deletes a [config][google.android.overtheair.v1.Config].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual DeleteConfigResponse DeleteConfig(
            DeleteConfigRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Updates a [config][google.android.overtheair.v1.Config].
        /// Returns `INVALID_ARGUMENT` if the name of the config is non-empty and does
        /// not equal the existing name.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/configs/config_a"
        /// </param>
        /// <param name="config">
        /// The [Config][google.android.overtheair.v1.Config] to update.
        /// </param>
        /// <param name="versionTag">
        /// Required. The config to be updated should match this version.
        /// If another client updates the existing config concurrently, the
        /// update operation will fail.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Config> UpdateConfigAsync(
            string name,
            Config config,
            VersionTag versionTag,
            gaxgrpc::CallSettings callSettings = null) => UpdateConfigAsync(
                new UpdateConfigRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    Config = gax::GaxPreconditions.CheckNotNull(config, nameof(config)),
                    VersionTag = gax::GaxPreconditions.CheckNotNull(versionTag, nameof(versionTag)),
                },
                callSettings);

        /// <summary>
        /// Updates a [config][google.android.overtheair.v1.Config].
        /// Returns `INVALID_ARGUMENT` if the name of the config is non-empty and does
        /// not equal the existing name.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/configs/config_a"
        /// </param>
        /// <param name="config">
        /// The [Config][google.android.overtheair.v1.Config] to update.
        /// </param>
        /// <param name="versionTag">
        /// Required. The config to be updated should match this version.
        /// If another client updates the existing config concurrently, the
        /// update operation will fail.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Config> UpdateConfigAsync(
            string name,
            Config config,
            VersionTag versionTag,
            st::CancellationToken cancellationToken) => UpdateConfigAsync(
                name,
                config,
                versionTag,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Updates a [config][google.android.overtheair.v1.Config].
        /// Returns `INVALID_ARGUMENT` if the name of the config is non-empty and does
        /// not equal the existing name.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/configs/config_a"
        /// </param>
        /// <param name="config">
        /// The [Config][google.android.overtheair.v1.Config] to update.
        /// </param>
        /// <param name="versionTag">
        /// Required. The config to be updated should match this version.
        /// If another client updates the existing config concurrently, the
        /// update operation will fail.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual Config UpdateConfig(
            string name,
            Config config,
            VersionTag versionTag,
            gaxgrpc::CallSettings callSettings = null) => UpdateConfig(
                new UpdateConfigRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    Config = gax::GaxPreconditions.CheckNotNull(config, nameof(config)),
                    VersionTag = gax::GaxPreconditions.CheckNotNull(versionTag, nameof(versionTag)),
                },
                callSettings);

        /// <summary>
        /// Updates a [config][google.android.overtheair.v1.Config].
        /// Returns `INVALID_ARGUMENT` if the name of the config is non-empty and does
        /// not equal the existing name.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Config> UpdateConfigAsync(
            UpdateConfigRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Updates a [config][google.android.overtheair.v1.Config].
        /// Returns `INVALID_ARGUMENT` if the name of the config is non-empty and does
        /// not equal the existing name.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Config> UpdateConfigAsync(
            UpdateConfigRequest request,
            st::CancellationToken cancellationToken) => UpdateConfigAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Updates a [config][google.android.overtheair.v1.Config].
        /// Returns `INVALID_ARGUMENT` if the name of the config is non-empty and does
        /// not equal the existing name.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual Config UpdateConfig(
            UpdateConfigRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Creates a group, and returns the new
        /// [Group][google.android.overtheair.v1.Group].
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x"
        /// </param>
        /// <param name="group">
        /// Required. The [Group][google.android.overtheair.v1.Group] to create.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Group> CreateGroupAsync(
            string name,
            Group group,
            gaxgrpc::CallSettings callSettings = null) => CreateGroupAsync(
                new CreateGroupRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    Group = gax::GaxPreconditions.CheckNotNull(group, nameof(group)),
                },
                callSettings);

        /// <summary>
        /// Creates a group, and returns the new
        /// [Group][google.android.overtheair.v1.Group].
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x"
        /// </param>
        /// <param name="group">
        /// Required. The [Group][google.android.overtheair.v1.Group] to create.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Group> CreateGroupAsync(
            string name,
            Group group,
            st::CancellationToken cancellationToken) => CreateGroupAsync(
                name,
                group,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Creates a group, and returns the new
        /// [Group][google.android.overtheair.v1.Group].
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x"
        /// </param>
        /// <param name="group">
        /// Required. The [Group][google.android.overtheair.v1.Group] to create.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual Group CreateGroup(
            string name,
            Group group,
            gaxgrpc::CallSettings callSettings = null) => CreateGroup(
                new CreateGroupRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    Group = gax::GaxPreconditions.CheckNotNull(group, nameof(group)),
                },
                callSettings);

        /// <summary>
        /// Creates a group, and returns the new
        /// [Group][google.android.overtheair.v1.Group].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Group> CreateGroupAsync(
            CreateGroupRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Creates a group, and returns the new
        /// [Group][google.android.overtheair.v1.Group].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Group> CreateGroupAsync(
            CreateGroupRequest request,
            st::CancellationToken cancellationToken) => CreateGroupAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Creates a group, and returns the new
        /// [Group][google.android.overtheair.v1.Group].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual Group CreateGroup(
            CreateGroupRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Gets a [group][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the group does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of the group
        /// should be returned.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Group> GetGroupAsync(
            string name,
            View? view,
            gaxgrpc::CallSettings callSettings = null) => GetGroupAsync(
                new GetGroupRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    View = view ?? View.Basic, // Optional
                },
                callSettings);

        /// <summary>
        /// Gets a [group][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the group does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of the group
        /// should be returned.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Group> GetGroupAsync(
            string name,
            View? view,
            st::CancellationToken cancellationToken) => GetGroupAsync(
                name,
                view,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Gets a [group][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the group does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of the group
        /// should be returned.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual Group GetGroup(
            string name,
            View? view,
            gaxgrpc::CallSettings callSettings = null) => GetGroup(
                new GetGroupRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    View = view ?? View.Basic, // Optional
                },
                callSettings);

        /// <summary>
        /// Gets a [group][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the group does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Group> GetGroupAsync(
            GetGroupRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Gets a [group][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the group does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Group> GetGroupAsync(
            GetGroupRequest request,
            st::CancellationToken cancellationToken) => GetGroupAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Gets a [group][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the group does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual Group GetGroup(
            GetGroupRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Lists [groups][google.android.overtheair.v1.Group] of a deployment.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of each group
        /// should be returned.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListGroupsResponse> ListGroupsAsync(
            string name,
            View? view,
            gaxgrpc::CallSettings callSettings = null) => ListGroupsAsync(
                new ListGroupsRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    View = view ?? View.Basic, // Optional
                },
                callSettings);

        /// <summary>
        /// Lists [groups][google.android.overtheair.v1.Group] of a deployment.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of each group
        /// should be returned.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListGroupsResponse> ListGroupsAsync(
            string name,
            View? view,
            st::CancellationToken cancellationToken) => ListGroupsAsync(
                name,
                view,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Lists [groups][google.android.overtheair.v1.Group] of a deployment.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of each group
        /// should be returned.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual ListGroupsResponse ListGroups(
            string name,
            View? view,
            gaxgrpc::CallSettings callSettings = null) => ListGroups(
                new ListGroupsRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    View = view ?? View.Basic, // Optional
                },
                callSettings);

        /// <summary>
        /// Lists [groups][google.android.overtheair.v1.Group] of a deployment.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListGroupsResponse> ListGroupsAsync(
            ListGroupsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Lists [groups][google.android.overtheair.v1.Group] of a deployment.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListGroupsResponse> ListGroupsAsync(
            ListGroupsRequest request,
            st::CancellationToken cancellationToken) => ListGroupsAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Lists [groups][google.android.overtheair.v1.Group] of a deployment.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual ListGroupsResponse ListGroups(
            ListGroupsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Deletes a [group][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the group does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g"
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DeleteGroupResponse> DeleteGroupAsync(
            string name,
            gaxgrpc::CallSettings callSettings = null) => DeleteGroupAsync(
                new DeleteGroupRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                },
                callSettings);

        /// <summary>
        /// Deletes a [group][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the group does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g"
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DeleteGroupResponse> DeleteGroupAsync(
            string name,
            st::CancellationToken cancellationToken) => DeleteGroupAsync(
                name,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Deletes a [group][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the group does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g"
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual DeleteGroupResponse DeleteGroup(
            string name,
            gaxgrpc::CallSettings callSettings = null) => DeleteGroup(
                new DeleteGroupRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                },
                callSettings);

        /// <summary>
        /// Deletes a [group][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the group does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DeleteGroupResponse> DeleteGroupAsync(
            DeleteGroupRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Deletes a [group][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the group does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DeleteGroupResponse> DeleteGroupAsync(
            DeleteGroupRequest request,
            st::CancellationToken cancellationToken) => DeleteGroupAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Deletes a [group][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the group does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual DeleteGroupResponse DeleteGroup(
            DeleteGroupRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Updates a [group][google.android.overtheair.v1.Group].
        /// Returns INVALID_ARGUMENT if the name of the group is non-empty and does
        /// not equal the existing name.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g"
        /// </param>
        /// <param name="group">
        /// Required. The [Group][google.android.overtheair.v1.Group] to update.
        /// </param>
        /// <param name="versionTag">
        /// Required. The group to be updated should match this version.
        /// If another client updates the existing config concurrently, the
        /// update operation will fail.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Group> UpdateGroupAsync(
            string name,
            Group group,
            VersionTag versionTag,
            gaxgrpc::CallSettings callSettings = null) => UpdateGroupAsync(
                new UpdateGroupRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    Group = gax::GaxPreconditions.CheckNotNull(group, nameof(group)),
                    VersionTag = gax::GaxPreconditions.CheckNotNull(versionTag, nameof(versionTag)),
                },
                callSettings);

        /// <summary>
        /// Updates a [group][google.android.overtheair.v1.Group].
        /// Returns INVALID_ARGUMENT if the name of the group is non-empty and does
        /// not equal the existing name.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g"
        /// </param>
        /// <param name="group">
        /// Required. The [Group][google.android.overtheair.v1.Group] to update.
        /// </param>
        /// <param name="versionTag">
        /// Required. The group to be updated should match this version.
        /// If another client updates the existing config concurrently, the
        /// update operation will fail.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Group> UpdateGroupAsync(
            string name,
            Group group,
            VersionTag versionTag,
            st::CancellationToken cancellationToken) => UpdateGroupAsync(
                name,
                group,
                versionTag,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Updates a [group][google.android.overtheair.v1.Group].
        /// Returns INVALID_ARGUMENT if the name of the group is non-empty and does
        /// not equal the existing name.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g"
        /// </param>
        /// <param name="group">
        /// Required. The [Group][google.android.overtheair.v1.Group] to update.
        /// </param>
        /// <param name="versionTag">
        /// Required. The group to be updated should match this version.
        /// If another client updates the existing config concurrently, the
        /// update operation will fail.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual Group UpdateGroup(
            string name,
            Group group,
            VersionTag versionTag,
            gaxgrpc::CallSettings callSettings = null) => UpdateGroup(
                new UpdateGroupRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    Group = gax::GaxPreconditions.CheckNotNull(group, nameof(group)),
                    VersionTag = gax::GaxPreconditions.CheckNotNull(versionTag, nameof(versionTag)),
                },
                callSettings);

        /// <summary>
        /// Updates a [group][google.android.overtheair.v1.Group].
        /// Returns INVALID_ARGUMENT if the name of the group is non-empty and does
        /// not equal the existing name.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Group> UpdateGroupAsync(
            UpdateGroupRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Updates a [group][google.android.overtheair.v1.Group].
        /// Returns INVALID_ARGUMENT if the name of the group is non-empty and does
        /// not equal the existing name.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Group> UpdateGroupAsync(
            UpdateGroupRequest request,
            st::CancellationToken cancellationToken) => UpdateGroupAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Updates a [group][google.android.overtheair.v1.Group].
        /// Returns INVALID_ARGUMENT if the name of the group is non-empty and does
        /// not equal the existing name.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual Group UpdateGroup(
            UpdateGroupRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Disables the defined [groups][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x/groups"
        /// </param>
        /// <param name="groupNames">
        /// Required. The groups that should be disabled.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DisableGroupsResponse> DisableGroupsAsync(
            string name,
            scg::IEnumerable<string> groupNames,
            gaxgrpc::CallSettings callSettings = null) => DisableGroupsAsync(
                new DisableGroupsRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    GroupNames = { gax::GaxPreconditions.CheckNotNull(groupNames, nameof(groupNames)) },
                },
                callSettings);

        /// <summary>
        /// Disables the defined [groups][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x/groups"
        /// </param>
        /// <param name="groupNames">
        /// Required. The groups that should be disabled.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DisableGroupsResponse> DisableGroupsAsync(
            string name,
            scg::IEnumerable<string> groupNames,
            st::CancellationToken cancellationToken) => DisableGroupsAsync(
                name,
                groupNames,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Disables the defined [groups][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x/groups"
        /// </param>
        /// <param name="groupNames">
        /// Required. The groups that should be disabled.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual DisableGroupsResponse DisableGroups(
            string name,
            scg::IEnumerable<string> groupNames,
            gaxgrpc::CallSettings callSettings = null) => DisableGroups(
                new DisableGroupsRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    GroupNames = { gax::GaxPreconditions.CheckNotNull(groupNames, nameof(groupNames)) },
                },
                callSettings);

        /// <summary>
        /// Disables the defined [groups][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DisableGroupsResponse> DisableGroupsAsync(
            DisableGroupsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Disables the defined [groups][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DisableGroupsResponse> DisableGroupsAsync(
            DisableGroupsRequest request,
            st::CancellationToken cancellationToken) => DisableGroupsAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Disables the defined [groups][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual DisableGroupsResponse DisableGroups(
            DisableGroupsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Enables the defined [groups][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x/groups"
        /// </param>
        /// <param name="groupNames">
        /// Required. The groups should be enabled.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<EnableGroupsResponse> EnableGroupsAsync(
            string name,
            scg::IEnumerable<string> groupNames,
            gaxgrpc::CallSettings callSettings = null) => EnableGroupsAsync(
                new EnableGroupsRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    GroupNames = { gax::GaxPreconditions.CheckNotNull(groupNames, nameof(groupNames)) },
                },
                callSettings);

        /// <summary>
        /// Enables the defined [groups][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x/groups"
        /// </param>
        /// <param name="groupNames">
        /// Required. The groups should be enabled.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<EnableGroupsResponse> EnableGroupsAsync(
            string name,
            scg::IEnumerable<string> groupNames,
            st::CancellationToken cancellationToken) => EnableGroupsAsync(
                name,
                groupNames,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Enables the defined [groups][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example: "deployments/deployment_x/groups"
        /// </param>
        /// <param name="groupNames">
        /// Required. The groups should be enabled.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual EnableGroupsResponse EnableGroups(
            string name,
            scg::IEnumerable<string> groupNames,
            gaxgrpc::CallSettings callSettings = null) => EnableGroups(
                new EnableGroupsRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    GroupNames = { gax::GaxPreconditions.CheckNotNull(groupNames, nameof(groupNames)) },
                },
                callSettings);

        /// <summary>
        /// Enables the defined [groups][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<EnableGroupsResponse> EnableGroupsAsync(
            EnableGroupsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Enables the defined [groups][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<EnableGroupsResponse> EnableGroupsAsync(
            EnableGroupsRequest request,
            st::CancellationToken cancellationToken) => EnableGroupsAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Enables the defined [groups][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual EnableGroupsResponse EnableGroups(
            EnableGroupsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Creates a group member and returns the new
        /// [GroupMember][google.android.overtheair.v1.GroupMember]. If the device is
        /// already under other groups, it will be removed from those groups and added
        /// to the group that's specified in the request.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g/members"
        /// </param>
        /// <param name="groupMember">
        /// Required. The [group member][google.android.overtheair.v1.GroupMember] to
        /// create.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<GroupMember> CreateGroupMemberAsync(
            string name,
            GroupMember groupMember,
            gaxgrpc::CallSettings callSettings = null) => CreateGroupMemberAsync(
                new CreateGroupMemberRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    GroupMember = gax::GaxPreconditions.CheckNotNull(groupMember, nameof(groupMember)),
                },
                callSettings);

        /// <summary>
        /// Creates a group member and returns the new
        /// [GroupMember][google.android.overtheair.v1.GroupMember]. If the device is
        /// already under other groups, it will be removed from those groups and added
        /// to the group that's specified in the request.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g/members"
        /// </param>
        /// <param name="groupMember">
        /// Required. The [group member][google.android.overtheair.v1.GroupMember] to
        /// create.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<GroupMember> CreateGroupMemberAsync(
            string name,
            GroupMember groupMember,
            st::CancellationToken cancellationToken) => CreateGroupMemberAsync(
                name,
                groupMember,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Creates a group member and returns the new
        /// [GroupMember][google.android.overtheair.v1.GroupMember]. If the device is
        /// already under other groups, it will be removed from those groups and added
        /// to the group that's specified in the request.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g/members"
        /// </param>
        /// <param name="groupMember">
        /// Required. The [group member][google.android.overtheair.v1.GroupMember] to
        /// create.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual GroupMember CreateGroupMember(
            string name,
            GroupMember groupMember,
            gaxgrpc::CallSettings callSettings = null) => CreateGroupMember(
                new CreateGroupMemberRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    GroupMember = gax::GaxPreconditions.CheckNotNull(groupMember, nameof(groupMember)),
                },
                callSettings);

        /// <summary>
        /// Creates a group member and returns the new
        /// [GroupMember][google.android.overtheair.v1.GroupMember]. If the device is
        /// already under other groups, it will be removed from those groups and added
        /// to the group that's specified in the request.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<GroupMember> CreateGroupMemberAsync(
            CreateGroupMemberRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Creates a group member and returns the new
        /// [GroupMember][google.android.overtheair.v1.GroupMember]. If the device is
        /// already under other groups, it will be removed from those groups and added
        /// to the group that's specified in the request.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<GroupMember> CreateGroupMemberAsync(
            CreateGroupMemberRequest request,
            st::CancellationToken cancellationToken) => CreateGroupMemberAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Creates a group member and returns the new
        /// [GroupMember][google.android.overtheair.v1.GroupMember]. If the device is
        /// already under other groups, it will be removed from those groups and added
        /// to the group that's specified in the request.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual GroupMember CreateGroupMember(
            CreateGroupMemberRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Creates group members in a specific group.  If any device is in other
        /// groups, it will be removed from those groups and added to the group that's
        /// specified in the request.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g/members"
        /// </param>
        /// <param name="groupMembers">
        /// Required. The list of
        /// [group member][google.android.overtheair.v1.GroupMember]s to create.
        /// This list is currently limited to no more than 1,000 members.  If you
        /// need to create more than that, please send multiple requests.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<CreateGroupMembersResponse> CreateGroupMembersAsync(
            string name,
            scg::IEnumerable<GroupMember> groupMembers,
            gaxgrpc::CallSettings callSettings = null) => CreateGroupMembersAsync(
                new CreateGroupMembersRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    GroupMembers = { gax::GaxPreconditions.CheckNotNull(groupMembers, nameof(groupMembers)) },
                },
                callSettings);

        /// <summary>
        /// Creates group members in a specific group.  If any device is in other
        /// groups, it will be removed from those groups and added to the group that's
        /// specified in the request.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g/members"
        /// </param>
        /// <param name="groupMembers">
        /// Required. The list of
        /// [group member][google.android.overtheair.v1.GroupMember]s to create.
        /// This list is currently limited to no more than 1,000 members.  If you
        /// need to create more than that, please send multiple requests.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<CreateGroupMembersResponse> CreateGroupMembersAsync(
            string name,
            scg::IEnumerable<GroupMember> groupMembers,
            st::CancellationToken cancellationToken) => CreateGroupMembersAsync(
                name,
                groupMembers,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Creates group members in a specific group.  If any device is in other
        /// groups, it will be removed from those groups and added to the group that's
        /// specified in the request.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g/members"
        /// </param>
        /// <param name="groupMembers">
        /// Required. The list of
        /// [group member][google.android.overtheair.v1.GroupMember]s to create.
        /// This list is currently limited to no more than 1,000 members.  If you
        /// need to create more than that, please send multiple requests.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual CreateGroupMembersResponse CreateGroupMembers(
            string name,
            scg::IEnumerable<GroupMember> groupMembers,
            gaxgrpc::CallSettings callSettings = null) => CreateGroupMembers(
                new CreateGroupMembersRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    GroupMembers = { gax::GaxPreconditions.CheckNotNull(groupMembers, nameof(groupMembers)) },
                },
                callSettings);

        /// <summary>
        /// Creates group members in a specific group.  If any device is in other
        /// groups, it will be removed from those groups and added to the group that's
        /// specified in the request.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<CreateGroupMembersResponse> CreateGroupMembersAsync(
            CreateGroupMembersRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Creates group members in a specific group.  If any device is in other
        /// groups, it will be removed from those groups and added to the group that's
        /// specified in the request.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<CreateGroupMembersResponse> CreateGroupMembersAsync(
            CreateGroupMembersRequest request,
            st::CancellationToken cancellationToken) => CreateGroupMembersAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Creates group members in a specific group.  If any device is in other
        /// groups, it will be removed from those groups and added to the group that's
        /// specified in the request.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual CreateGroupMembersResponse CreateGroupMembers(
            CreateGroupMembersRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Gets a [group member][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example:
        /// "deployments/deployment_x/groups/group_g/members/member_m"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of the group member
        /// should be returned.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<GroupMember> GetGroupMemberAsync(
            string name,
            View? view,
            gaxgrpc::CallSettings callSettings = null) => GetGroupMemberAsync(
                new GetGroupMemberRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    View = view ?? View.Basic, // Optional
                },
                callSettings);

        /// <summary>
        /// Gets a [group member][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example:
        /// "deployments/deployment_x/groups/group_g/members/member_m"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of the group member
        /// should be returned.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<GroupMember> GetGroupMemberAsync(
            string name,
            View? view,
            st::CancellationToken cancellationToken) => GetGroupMemberAsync(
                name,
                view,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Gets a [group member][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example:
        /// "deployments/deployment_x/groups/group_g/members/member_m"
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of the group member
        /// should be returned.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual GroupMember GetGroupMember(
            string name,
            View? view,
            gaxgrpc::CallSettings callSettings = null) => GetGroupMember(
                new GetGroupMemberRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    View = view ?? View.Basic, // Optional
                },
                callSettings);

        /// <summary>
        /// Gets a [group member][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<GroupMember> GetGroupMemberAsync(
            GetGroupMemberRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Gets a [group member][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<GroupMember> GetGroupMemberAsync(
            GetGroupMemberRequest request,
            st::CancellationToken cancellationToken) => GetGroupMemberAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Gets a [group member][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual GroupMember GetGroupMember(
            GetGroupMemberRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Lists [group members][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g/members"
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListGroupMembersResponse> ListGroupMembersAsync(
            string name,
            gaxgrpc::CallSettings callSettings = null) => ListGroupMembersAsync(
                new ListGroupMembersRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                },
                callSettings);

        /// <summary>
        /// Lists [group members][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g/members"
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListGroupMembersResponse> ListGroupMembersAsync(
            string name,
            st::CancellationToken cancellationToken) => ListGroupMembersAsync(
                name,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Lists [group members][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g/members"
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual ListGroupMembersResponse ListGroupMembers(
            string name,
            gaxgrpc::CallSettings callSettings = null) => ListGroupMembers(
                new ListGroupMembersRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                },
                callSettings);

        /// <summary>
        /// Lists [group members][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListGroupMembersResponse> ListGroupMembersAsync(
            ListGroupMembersRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Lists [group members][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListGroupMembersResponse> ListGroupMembersAsync(
            ListGroupMembersRequest request,
            st::CancellationToken cancellationToken) => ListGroupMembersAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Lists [group members][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual ListGroupMembersResponse ListGroupMembers(
            ListGroupMembersRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Deletes a [group member][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example:
        /// "deployments/deployment_x/groups/group_g/members/member_m"
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DeleteGroupMemberResponse> DeleteGroupMemberAsync(
            string name,
            gaxgrpc::CallSettings callSettings = null) => DeleteGroupMemberAsync(
                new DeleteGroupMemberRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                },
                callSettings);

        /// <summary>
        /// Deletes a [group member][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example:
        /// "deployments/deployment_x/groups/group_g/members/member_m"
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DeleteGroupMemberResponse> DeleteGroupMemberAsync(
            string name,
            st::CancellationToken cancellationToken) => DeleteGroupMemberAsync(
                name,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Deletes a [group member][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example:
        /// "deployments/deployment_x/groups/group_g/members/member_m"
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual DeleteGroupMemberResponse DeleteGroupMember(
            string name,
            gaxgrpc::CallSettings callSettings = null) => DeleteGroupMember(
                new DeleteGroupMemberRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                },
                callSettings);

        /// <summary>
        /// Deletes a [group member][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DeleteGroupMemberResponse> DeleteGroupMemberAsync(
            DeleteGroupMemberRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Deletes a [group member][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DeleteGroupMemberResponse> DeleteGroupMemberAsync(
            DeleteGroupMemberRequest request,
            st::CancellationToken cancellationToken) => DeleteGroupMemberAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Deletes a [group member][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual DeleteGroupMemberResponse DeleteGroupMember(
            DeleteGroupMemberRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Deletes group members in a group.  If any member does not it exist, it
        /// will be ignored.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example:
        /// "deployments/deployment_x/groups/group_g/members"
        /// </param>
        /// <param name="groupMembers">
        /// Required. The list of
        /// [group member][google.android.overtheair.v1.GroupMember] to delete.
        /// This list is currently limited to no more than 1,000 members.  If you
        /// need to delete more than that, please send multiple requests.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DeleteGroupMembersResponse> DeleteGroupMembersAsync(
            string name,
            scg::IEnumerable<GroupMember> groupMembers,
            gaxgrpc::CallSettings callSettings = null) => DeleteGroupMembersAsync(
                new DeleteGroupMembersRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    GroupMembers = { gax::GaxPreconditions.CheckNotNull(groupMembers, nameof(groupMembers)) },
                },
                callSettings);

        /// <summary>
        /// Deletes group members in a group.  If any member does not it exist, it
        /// will be ignored.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example:
        /// "deployments/deployment_x/groups/group_g/members"
        /// </param>
        /// <param name="groupMembers">
        /// Required. The list of
        /// [group member][google.android.overtheair.v1.GroupMember] to delete.
        /// This list is currently limited to no more than 1,000 members.  If you
        /// need to delete more than that, please send multiple requests.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DeleteGroupMembersResponse> DeleteGroupMembersAsync(
            string name,
            scg::IEnumerable<GroupMember> groupMembers,
            st::CancellationToken cancellationToken) => DeleteGroupMembersAsync(
                name,
                groupMembers,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Deletes group members in a group.  If any member does not it exist, it
        /// will be ignored.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example:
        /// "deployments/deployment_x/groups/group_g/members"
        /// </param>
        /// <param name="groupMembers">
        /// Required. The list of
        /// [group member][google.android.overtheair.v1.GroupMember] to delete.
        /// This list is currently limited to no more than 1,000 members.  If you
        /// need to delete more than that, please send multiple requests.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual DeleteGroupMembersResponse DeleteGroupMembers(
            string name,
            scg::IEnumerable<GroupMember> groupMembers,
            gaxgrpc::CallSettings callSettings = null) => DeleteGroupMembers(
                new DeleteGroupMembersRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    GroupMembers = { gax::GaxPreconditions.CheckNotNull(groupMembers, nameof(groupMembers)) },
                },
                callSettings);

        /// <summary>
        /// Deletes group members in a group.  If any member does not it exist, it
        /// will be ignored.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DeleteGroupMembersResponse> DeleteGroupMembersAsync(
            DeleteGroupMembersRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Deletes group members in a group.  If any member does not it exist, it
        /// will be ignored.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DeleteGroupMembersResponse> DeleteGroupMembersAsync(
            DeleteGroupMembersRequest request,
            st::CancellationToken cancellationToken) => DeleteGroupMembersAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Deletes group members in a group.  If any member does not it exist, it
        /// will be ignored.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual DeleteGroupMembersResponse DeleteGroupMembers(
            DeleteGroupMembersRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Gets a [group chart][google.android.overtheair.v1.Chart].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example:
        /// "deployments/deployment_x/groups/group_g/charts/chart_c"
        /// </param>
        /// <param name="options">
        /// Optional. Chart Options.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Chart> GetGroupChartAsync(
            string name,
            ChartOptions options,
            gaxgrpc::CallSettings callSettings = null) => GetGroupChartAsync(
                new GetGroupChartRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    Options = options, // Optional
                },
                callSettings);

        /// <summary>
        /// Gets a [group chart][google.android.overtheair.v1.Chart].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example:
        /// "deployments/deployment_x/groups/group_g/charts/chart_c"
        /// </param>
        /// <param name="options">
        /// Optional. Chart Options.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Chart> GetGroupChartAsync(
            string name,
            ChartOptions options,
            st::CancellationToken cancellationToken) => GetGroupChartAsync(
                name,
                options,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Gets a [group chart][google.android.overtheair.v1.Chart].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.  For example:
        /// "deployments/deployment_x/groups/group_g/charts/chart_c"
        /// </param>
        /// <param name="options">
        /// Optional. Chart Options.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual Chart GetGroupChart(
            string name,
            ChartOptions options,
            gaxgrpc::CallSettings callSettings = null) => GetGroupChart(
                new GetGroupChartRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    Options = options, // Optional
                },
                callSettings);

        /// <summary>
        /// Gets a [group chart][google.android.overtheair.v1.Chart].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Chart> GetGroupChartAsync(
            GetGroupChartRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Gets a [group chart][google.android.overtheair.v1.Chart].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<Chart> GetGroupChartAsync(
            GetGroupChartRequest request,
            st::CancellationToken cancellationToken) => GetGroupChartAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Gets a [group chart][google.android.overtheair.v1.Chart].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual Chart GetGroupChart(
            GetGroupChartRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Lists [group charts][google.android.overtheair.v1.Chart].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g"
        /// </param>
        /// <param name="options">
        /// Optional. Chart Options.
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of the group chart
        /// should be returned.  Basic data only includes chart names.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListGroupChartsResponse> ListGroupChartsAsync(
            string name,
            ChartOptions options,
            View? view,
            gaxgrpc::CallSettings callSettings = null) => ListGroupChartsAsync(
                new ListGroupChartsRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    Options = options, // Optional
                    View = view ?? View.Basic, // Optional
                },
                callSettings);

        /// <summary>
        /// Lists [group charts][google.android.overtheair.v1.Chart].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g"
        /// </param>
        /// <param name="options">
        /// Optional. Chart Options.
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of the group chart
        /// should be returned.  Basic data only includes chart names.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListGroupChartsResponse> ListGroupChartsAsync(
            string name,
            ChartOptions options,
            View? view,
            st::CancellationToken cancellationToken) => ListGroupChartsAsync(
                name,
                options,
                view,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Lists [group charts][google.android.overtheair.v1.Chart].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g"
        /// </param>
        /// <param name="options">
        /// Optional. Chart Options.
        /// </param>
        /// <param name="view">
        /// Optional. Specify whether basic or detailed information of the group chart
        /// should be returned.  Basic data only includes chart names.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual ListGroupChartsResponse ListGroupCharts(
            string name,
            ChartOptions options,
            View? view,
            gaxgrpc::CallSettings callSettings = null) => ListGroupCharts(
                new ListGroupChartsRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    Options = options, // Optional
                    View = view ?? View.Basic, // Optional
                },
                callSettings);

        /// <summary>
        /// Lists [group charts][google.android.overtheair.v1.Chart].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListGroupChartsResponse> ListGroupChartsAsync(
            ListGroupChartsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Lists [group charts][google.android.overtheair.v1.Chart].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListGroupChartsResponse> ListGroupChartsAsync(
            ListGroupChartsRequest request,
            st::CancellationToken cancellationToken) => ListGroupChartsAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Lists [group charts][google.android.overtheair.v1.Chart].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual ListGroupChartsResponse ListGroupCharts(
            ListGroupChartsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Lists configs of the group. Returns `NOT_FOUND` if the matching path
        /// does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g"
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListGroupConfigsResponse> ListGroupConfigsAsync(
            string name,
            gaxgrpc::CallSettings callSettings = null) => ListGroupConfigsAsync(
                new ListGroupConfigsRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                },
                callSettings);

        /// <summary>
        /// Lists configs of the group. Returns `NOT_FOUND` if the matching path
        /// does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g"
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListGroupConfigsResponse> ListGroupConfigsAsync(
            string name,
            st::CancellationToken cancellationToken) => ListGroupConfigsAsync(
                name,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Lists configs of the group. Returns `NOT_FOUND` if the matching path
        /// does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g"
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual ListGroupConfigsResponse ListGroupConfigs(
            string name,
            gaxgrpc::CallSettings callSettings = null) => ListGroupConfigs(
                new ListGroupConfigsRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                },
                callSettings);

        /// <summary>
        /// Lists configs of the group. Returns `NOT_FOUND` if the matching path
        /// does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListGroupConfigsResponse> ListGroupConfigsAsync(
            ListGroupConfigsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Lists configs of the group. Returns `NOT_FOUND` if the matching path
        /// does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListGroupConfigsResponse> ListGroupConfigsAsync(
            ListGroupConfigsRequest request,
            st::CancellationToken cancellationToken) => ListGroupConfigsAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Lists configs of the group. Returns `NOT_FOUND` if the matching path
        /// does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual ListGroupConfigsResponse ListGroupConfigs(
            ListGroupConfigsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Update the configs under a group. Returns `NOT_FOUND` if the matching group
        /// or config does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g"
        /// </param>
        /// <param name="configNames">
        /// Required. The names of the configs under the group.
        /// Important: the order of configs is important. If a device matches
        /// multiple sets of packages across configs, the last matching config wins
        /// and will be used.
        /// </param>
        /// <param name="versionTag">
        /// Required. The group to be updated should match this version.
        /// If another client updates the existing group concurrently, the
        /// update operation will fail.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<UpdateGroupConfigsResponse> UpdateGroupConfigsAsync(
            string name,
            scg::IEnumerable<string> configNames,
            VersionTag versionTag,
            gaxgrpc::CallSettings callSettings = null) => UpdateGroupConfigsAsync(
                new UpdateGroupConfigsRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    ConfigNames = { gax::GaxPreconditions.CheckNotNull(configNames, nameof(configNames)) },
                    VersionTag = gax::GaxPreconditions.CheckNotNull(versionTag, nameof(versionTag)),
                },
                callSettings);

        /// <summary>
        /// Update the configs under a group. Returns `NOT_FOUND` if the matching group
        /// or config does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g"
        /// </param>
        /// <param name="configNames">
        /// Required. The names of the configs under the group.
        /// Important: the order of configs is important. If a device matches
        /// multiple sets of packages across configs, the last matching config wins
        /// and will be used.
        /// </param>
        /// <param name="versionTag">
        /// Required. The group to be updated should match this version.
        /// If another client updates the existing group concurrently, the
        /// update operation will fail.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<UpdateGroupConfigsResponse> UpdateGroupConfigsAsync(
            string name,
            scg::IEnumerable<string> configNames,
            VersionTag versionTag,
            st::CancellationToken cancellationToken) => UpdateGroupConfigsAsync(
                name,
                configNames,
                versionTag,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Update the configs under a group. Returns `NOT_FOUND` if the matching group
        /// or config does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/groups/group_g"
        /// </param>
        /// <param name="configNames">
        /// Required. The names of the configs under the group.
        /// Important: the order of configs is important. If a device matches
        /// multiple sets of packages across configs, the last matching config wins
        /// and will be used.
        /// </param>
        /// <param name="versionTag">
        /// Required. The group to be updated should match this version.
        /// If another client updates the existing group concurrently, the
        /// update operation will fail.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual UpdateGroupConfigsResponse UpdateGroupConfigs(
            string name,
            scg::IEnumerable<string> configNames,
            VersionTag versionTag,
            gaxgrpc::CallSettings callSettings = null) => UpdateGroupConfigs(
                new UpdateGroupConfigsRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    ConfigNames = { gax::GaxPreconditions.CheckNotNull(configNames, nameof(configNames)) },
                    VersionTag = gax::GaxPreconditions.CheckNotNull(versionTag, nameof(versionTag)),
                },
                callSettings);

        /// <summary>
        /// Update the configs under a group. Returns `NOT_FOUND` if the matching group
        /// or config does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<UpdateGroupConfigsResponse> UpdateGroupConfigsAsync(
            UpdateGroupConfigsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Update the configs under a group. Returns `NOT_FOUND` if the matching group
        /// or config does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<UpdateGroupConfigsResponse> UpdateGroupConfigsAsync(
            UpdateGroupConfigsRequest request,
            st::CancellationToken cancellationToken) => UpdateGroupConfigsAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Update the configs under a group. Returns `NOT_FOUND` if the matching group
        /// or config does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual UpdateGroupConfigsResponse UpdateGroupConfigs(
            UpdateGroupConfigsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Disables all enabled groups that have the specified config.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/configs/config_c"
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DisableAllEnabledGroupsOfConfigResponse> DisableAllEnabledGroupsOfConfigAsync(
            string name,
            gaxgrpc::CallSettings callSettings = null) => DisableAllEnabledGroupsOfConfigAsync(
                new DisableAllEnabledGroupsOfConfigRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                },
                callSettings);

        /// <summary>
        /// Disables all enabled groups that have the specified config.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/configs/config_c"
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DisableAllEnabledGroupsOfConfigResponse> DisableAllEnabledGroupsOfConfigAsync(
            string name,
            st::CancellationToken cancellationToken) => DisableAllEnabledGroupsOfConfigAsync(
                name,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Disables all enabled groups that have the specified config.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/configs/config_c"
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual DisableAllEnabledGroupsOfConfigResponse DisableAllEnabledGroupsOfConfig(
            string name,
            gaxgrpc::CallSettings callSettings = null) => DisableAllEnabledGroupsOfConfig(
                new DisableAllEnabledGroupsOfConfigRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                },
                callSettings);

        /// <summary>
        /// Disables all enabled groups that have the specified config.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DisableAllEnabledGroupsOfConfigResponse> DisableAllEnabledGroupsOfConfigAsync(
            DisableAllEnabledGroupsOfConfigRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Disables all enabled groups that have the specified config.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<DisableAllEnabledGroupsOfConfigResponse> DisableAllEnabledGroupsOfConfigAsync(
            DisableAllEnabledGroupsOfConfigRequest request,
            st::CancellationToken cancellationToken) => DisableAllEnabledGroupsOfConfigAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Disables all enabled groups that have the specified config.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual DisableAllEnabledGroupsOfConfigResponse DisableAllEnabledGroupsOfConfig(
            DisableAllEnabledGroupsOfConfigRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Lists packages of the config. Returns `NOT_FOUND` if the matching path does
        /// not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/configs/config_c"
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListConfigPackagesResponse> ListConfigPackagesAsync(
            string name,
            gaxgrpc::CallSettings callSettings = null) => ListConfigPackagesAsync(
                new ListConfigPackagesRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                },
                callSettings);

        /// <summary>
        /// Lists packages of the config. Returns `NOT_FOUND` if the matching path does
        /// not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/configs/config_c"
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListConfigPackagesResponse> ListConfigPackagesAsync(
            string name,
            st::CancellationToken cancellationToken) => ListConfigPackagesAsync(
                name,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Lists packages of the config. Returns `NOT_FOUND` if the matching path does
        /// not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/configs/config_c"
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual ListConfigPackagesResponse ListConfigPackages(
            string name,
            gaxgrpc::CallSettings callSettings = null) => ListConfigPackages(
                new ListConfigPackagesRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                },
                callSettings);

        /// <summary>
        /// Lists packages of the config. Returns `NOT_FOUND` if the matching path does
        /// not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListConfigPackagesResponse> ListConfigPackagesAsync(
            ListConfigPackagesRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Lists packages of the config. Returns `NOT_FOUND` if the matching path does
        /// not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListConfigPackagesResponse> ListConfigPackagesAsync(
            ListConfigPackagesRequest request,
            st::CancellationToken cancellationToken) => ListConfigPackagesAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Lists packages of the config. Returns `NOT_FOUND` if the matching path does
        /// not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual ListConfigPackagesResponse ListConfigPackages(
            ListConfigPackagesRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Update the packages under the config. Returns `NOT_FOUND` if the matching
        /// path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/configs/config_c"
        /// </param>
        /// <param name="packageConfigs">
        /// Required. The names of the packages under the config.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<UpdateConfigPackagesResponse> UpdateConfigPackagesAsync(
            string name,
            scg::IEnumerable<PackageConfig> packageConfigs,
            gaxgrpc::CallSettings callSettings = null) => UpdateConfigPackagesAsync(
                new UpdateConfigPackagesRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    PackageConfigs = { gax::GaxPreconditions.CheckNotNull(packageConfigs, nameof(packageConfigs)) },
                },
                callSettings);

        /// <summary>
        /// Update the packages under the config. Returns `NOT_FOUND` if the matching
        /// path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/configs/config_c"
        /// </param>
        /// <param name="packageConfigs">
        /// Required. The names of the packages under the config.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<UpdateConfigPackagesResponse> UpdateConfigPackagesAsync(
            string name,
            scg::IEnumerable<PackageConfig> packageConfigs,
            st::CancellationToken cancellationToken) => UpdateConfigPackagesAsync(
                name,
                packageConfigs,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Update the packages under the config. Returns `NOT_FOUND` if the matching
        /// path does not exist.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/configs/config_c"
        /// </param>
        /// <param name="packageConfigs">
        /// Required. The names of the packages under the config.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual UpdateConfigPackagesResponse UpdateConfigPackages(
            string name,
            scg::IEnumerable<PackageConfig> packageConfigs,
            gaxgrpc::CallSettings callSettings = null) => UpdateConfigPackages(
                new UpdateConfigPackagesRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                    PackageConfigs = { gax::GaxPreconditions.CheckNotNull(packageConfigs, nameof(packageConfigs)) },
                },
                callSettings);

        /// <summary>
        /// Update the packages under the config. Returns `NOT_FOUND` if the matching
        /// path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<UpdateConfigPackagesResponse> UpdateConfigPackagesAsync(
            UpdateConfigPackagesRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Update the packages under the config. Returns `NOT_FOUND` if the matching
        /// path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<UpdateConfigPackagesResponse> UpdateConfigPackagesAsync(
            UpdateConfigPackagesRequest request,
            st::CancellationToken cancellationToken) => UpdateConfigPackagesAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Update the packages under the config. Returns `NOT_FOUND` if the matching
        /// path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual UpdateConfigPackagesResponse UpdateConfigPackages(
            UpdateConfigPackagesRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Lists all the configs that use the specified package.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/packages/package_a"
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListConfigsUsingPackageResponse> ListConfigsUsingPackageAsync(
            string name,
            gaxgrpc::CallSettings callSettings = null) => ListConfigsUsingPackageAsync(
                new ListConfigsUsingPackageRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                },
                callSettings);

        /// <summary>
        /// Lists all the configs that use the specified package.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/packages/package_a"
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListConfigsUsingPackageResponse> ListConfigsUsingPackageAsync(
            string name,
            st::CancellationToken cancellationToken) => ListConfigsUsingPackageAsync(
                name,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Lists all the configs that use the specified package.
        /// </summary>
        /// <param name="name">
        /// Relative resource name.
        /// For example: "deployments/deployment_x/packages/package_a"
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual ListConfigsUsingPackageResponse ListConfigsUsingPackage(
            string name,
            gaxgrpc::CallSettings callSettings = null) => ListConfigsUsingPackage(
                new ListConfigsUsingPackageRequest
                {
                    Name = gax::GaxPreconditions.CheckNotNullOrEmpty(name, nameof(name)),
                },
                callSettings);

        /// <summary>
        /// Lists all the configs that use the specified package.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListConfigsUsingPackageResponse> ListConfigsUsingPackageAsync(
            ListConfigsUsingPackageRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

        /// <summary>
        /// Lists all the configs that use the specified package.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="cancellationToken">
        /// A <see cref="st::CancellationToken"/> to use for this RPC.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public virtual stt::Task<ListConfigsUsingPackageResponse> ListConfigsUsingPackageAsync(
            ListConfigsUsingPackageRequest request,
            st::CancellationToken cancellationToken) => ListConfigsUsingPackageAsync(
                request,
                gaxgrpc::CallSettings.FromCancellationToken(cancellationToken));

        /// <summary>
        /// Lists all the configs that use the specified package.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public virtual ListConfigsUsingPackageResponse ListConfigsUsingPackage(
            ListConfigsUsingPackageRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            throw new sys::NotImplementedException();
        }

    }

    /// <summary>
    /// OverTheAirService client wrapper implementation, for convenient use.
    /// </summary>
    public sealed partial class OverTheAirServiceClientImpl : OverTheAirServiceClient
    {
        private readonly gaxgrpc::ApiCall<GetDeploymentRequest, Deployment> _callGetDeployment;
        private readonly gaxgrpc::ApiCall<ListDeploymentsRequest, ListDeploymentsResponse> _callListDeployments;
        private readonly gaxgrpc::ApiCall<UpdateDeploymentRequest, Deployment> _callUpdateDeployment;
        private readonly gaxgrpc::ApiCall<GetPackageRequest, Package> _callGetPackage;
        private readonly gaxgrpc::ApiCall<ListPackagesRequest, ListPackagesResponse> _callListPackages;
        private readonly gaxgrpc::ApiCall<DeletePackageRequest, DeletePackageResponse> _callDeletePackage;
        private readonly gaxgrpc::ApiCall<UpdatePackageRequest, Package> _callUpdatePackage;
        private readonly gaxgrpc::ApiCall<CreateConfigRequest, Config> _callCreateConfig;
        private readonly gaxgrpc::ApiCall<GetConfigRequest, Config> _callGetConfig;
        private readonly gaxgrpc::ApiCall<ListConfigsRequest, ListConfigsResponse> _callListConfigs;
        private readonly gaxgrpc::ApiCall<DeleteConfigRequest, DeleteConfigResponse> _callDeleteConfig;
        private readonly gaxgrpc::ApiCall<UpdateConfigRequest, Config> _callUpdateConfig;
        private readonly gaxgrpc::ApiCall<CreateGroupRequest, Group> _callCreateGroup;
        private readonly gaxgrpc::ApiCall<GetGroupRequest, Group> _callGetGroup;
        private readonly gaxgrpc::ApiCall<ListGroupsRequest, ListGroupsResponse> _callListGroups;
        private readonly gaxgrpc::ApiCall<DeleteGroupRequest, DeleteGroupResponse> _callDeleteGroup;
        private readonly gaxgrpc::ApiCall<UpdateGroupRequest, Group> _callUpdateGroup;
        private readonly gaxgrpc::ApiCall<DisableGroupsRequest, DisableGroupsResponse> _callDisableGroups;
        private readonly gaxgrpc::ApiCall<EnableGroupsRequest, EnableGroupsResponse> _callEnableGroups;
        private readonly gaxgrpc::ApiCall<CreateGroupMemberRequest, GroupMember> _callCreateGroupMember;
        private readonly gaxgrpc::ApiCall<CreateGroupMembersRequest, CreateGroupMembersResponse> _callCreateGroupMembers;
        private readonly gaxgrpc::ApiCall<GetGroupMemberRequest, GroupMember> _callGetGroupMember;
        private readonly gaxgrpc::ApiCall<ListGroupMembersRequest, ListGroupMembersResponse> _callListGroupMembers;
        private readonly gaxgrpc::ApiCall<DeleteGroupMemberRequest, DeleteGroupMemberResponse> _callDeleteGroupMember;
        private readonly gaxgrpc::ApiCall<DeleteGroupMembersRequest, DeleteGroupMembersResponse> _callDeleteGroupMembers;
        private readonly gaxgrpc::ApiCall<GetGroupChartRequest, Chart> _callGetGroupChart;
        private readonly gaxgrpc::ApiCall<ListGroupChartsRequest, ListGroupChartsResponse> _callListGroupCharts;
        private readonly gaxgrpc::ApiCall<ListGroupConfigsRequest, ListGroupConfigsResponse> _callListGroupConfigs;
        private readonly gaxgrpc::ApiCall<UpdateGroupConfigsRequest, UpdateGroupConfigsResponse> _callUpdateGroupConfigs;
        private readonly gaxgrpc::ApiCall<DisableAllEnabledGroupsOfConfigRequest, DisableAllEnabledGroupsOfConfigResponse> _callDisableAllEnabledGroupsOfConfig;
        private readonly gaxgrpc::ApiCall<ListConfigPackagesRequest, ListConfigPackagesResponse> _callListConfigPackages;
        private readonly gaxgrpc::ApiCall<UpdateConfigPackagesRequest, UpdateConfigPackagesResponse> _callUpdateConfigPackages;
        private readonly gaxgrpc::ApiCall<ListConfigsUsingPackageRequest, ListConfigsUsingPackageResponse> _callListConfigsUsingPackage;

        /// <summary>
        /// Constructs a client wrapper for the OverTheAirService service, with the specified gRPC client and settings.
        /// </summary>
        /// <param name="grpcClient">The underlying gRPC client.</param>
        /// <param name="settings">The base <see cref="OverTheAirServiceSettings"/> used within this client </param>
        public OverTheAirServiceClientImpl(OverTheAirService.OverTheAirServiceClient grpcClient, OverTheAirServiceSettings settings)
        {
            GrpcClient = grpcClient;
            OverTheAirServiceSettings effectiveSettings = settings ?? OverTheAirServiceSettings.GetDefault();
            gaxgrpc::ClientHelper clientHelper = new gaxgrpc::ClientHelper(effectiveSettings);
            _callGetDeployment = clientHelper.BuildApiCall<GetDeploymentRequest, Deployment>(
                GrpcClient.GetDeploymentAsync, GrpcClient.GetDeployment, effectiveSettings.GetDeploymentSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callListDeployments = clientHelper.BuildApiCall<ListDeploymentsRequest, ListDeploymentsResponse>(
                GrpcClient.ListDeploymentsAsync, GrpcClient.ListDeployments, effectiveSettings.ListDeploymentsSettings);
            _callUpdateDeployment = clientHelper.BuildApiCall<UpdateDeploymentRequest, Deployment>(
                GrpcClient.UpdateDeploymentAsync, GrpcClient.UpdateDeployment, effectiveSettings.UpdateDeploymentSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callGetPackage = clientHelper.BuildApiCall<GetPackageRequest, Package>(
                GrpcClient.GetPackageAsync, GrpcClient.GetPackage, effectiveSettings.GetPackageSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callListPackages = clientHelper.BuildApiCall<ListPackagesRequest, ListPackagesResponse>(
                GrpcClient.ListPackagesAsync, GrpcClient.ListPackages, effectiveSettings.ListPackagesSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callDeletePackage = clientHelper.BuildApiCall<DeletePackageRequest, DeletePackageResponse>(
                GrpcClient.DeletePackageAsync, GrpcClient.DeletePackage, effectiveSettings.DeletePackageSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callUpdatePackage = clientHelper.BuildApiCall<UpdatePackageRequest, Package>(
                GrpcClient.UpdatePackageAsync, GrpcClient.UpdatePackage, effectiveSettings.UpdatePackageSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callCreateConfig = clientHelper.BuildApiCall<CreateConfigRequest, Config>(
                GrpcClient.CreateConfigAsync, GrpcClient.CreateConfig, effectiveSettings.CreateConfigSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callGetConfig = clientHelper.BuildApiCall<GetConfigRequest, Config>(
                GrpcClient.GetConfigAsync, GrpcClient.GetConfig, effectiveSettings.GetConfigSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callListConfigs = clientHelper.BuildApiCall<ListConfigsRequest, ListConfigsResponse>(
                GrpcClient.ListConfigsAsync, GrpcClient.ListConfigs, effectiveSettings.ListConfigsSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callDeleteConfig = clientHelper.BuildApiCall<DeleteConfigRequest, DeleteConfigResponse>(
                GrpcClient.DeleteConfigAsync, GrpcClient.DeleteConfig, effectiveSettings.DeleteConfigSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callUpdateConfig = clientHelper.BuildApiCall<UpdateConfigRequest, Config>(
                GrpcClient.UpdateConfigAsync, GrpcClient.UpdateConfig, effectiveSettings.UpdateConfigSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callCreateGroup = clientHelper.BuildApiCall<CreateGroupRequest, Group>(
                GrpcClient.CreateGroupAsync, GrpcClient.CreateGroup, effectiveSettings.CreateGroupSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callGetGroup = clientHelper.BuildApiCall<GetGroupRequest, Group>(
                GrpcClient.GetGroupAsync, GrpcClient.GetGroup, effectiveSettings.GetGroupSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callListGroups = clientHelper.BuildApiCall<ListGroupsRequest, ListGroupsResponse>(
                GrpcClient.ListGroupsAsync, GrpcClient.ListGroups, effectiveSettings.ListGroupsSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callDeleteGroup = clientHelper.BuildApiCall<DeleteGroupRequest, DeleteGroupResponse>(
                GrpcClient.DeleteGroupAsync, GrpcClient.DeleteGroup, effectiveSettings.DeleteGroupSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callUpdateGroup = clientHelper.BuildApiCall<UpdateGroupRequest, Group>(
                GrpcClient.UpdateGroupAsync, GrpcClient.UpdateGroup, effectiveSettings.UpdateGroupSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callDisableGroups = clientHelper.BuildApiCall<DisableGroupsRequest, DisableGroupsResponse>(
                GrpcClient.DisableGroupsAsync, GrpcClient.DisableGroups, effectiveSettings.DisableGroupsSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callEnableGroups = clientHelper.BuildApiCall<EnableGroupsRequest, EnableGroupsResponse>(
                GrpcClient.EnableGroupsAsync, GrpcClient.EnableGroups, effectiveSettings.EnableGroupsSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callCreateGroupMember = clientHelper.BuildApiCall<CreateGroupMemberRequest, GroupMember>(
                GrpcClient.CreateGroupMemberAsync, GrpcClient.CreateGroupMember, effectiveSettings.CreateGroupMemberSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callCreateGroupMembers = clientHelper.BuildApiCall<CreateGroupMembersRequest, CreateGroupMembersResponse>(
                GrpcClient.CreateGroupMembersAsync, GrpcClient.CreateGroupMembers, effectiveSettings.CreateGroupMembersSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callGetGroupMember = clientHelper.BuildApiCall<GetGroupMemberRequest, GroupMember>(
                GrpcClient.GetGroupMemberAsync, GrpcClient.GetGroupMember, effectiveSettings.GetGroupMemberSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callListGroupMembers = clientHelper.BuildApiCall<ListGroupMembersRequest, ListGroupMembersResponse>(
                GrpcClient.ListGroupMembersAsync, GrpcClient.ListGroupMembers, effectiveSettings.ListGroupMembersSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callDeleteGroupMember = clientHelper.BuildApiCall<DeleteGroupMemberRequest, DeleteGroupMemberResponse>(
                GrpcClient.DeleteGroupMemberAsync, GrpcClient.DeleteGroupMember, effectiveSettings.DeleteGroupMemberSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callDeleteGroupMembers = clientHelper.BuildApiCall<DeleteGroupMembersRequest, DeleteGroupMembersResponse>(
                GrpcClient.DeleteGroupMembersAsync, GrpcClient.DeleteGroupMembers, effectiveSettings.DeleteGroupMembersSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callGetGroupChart = clientHelper.BuildApiCall<GetGroupChartRequest, Chart>(
                GrpcClient.GetGroupChartAsync, GrpcClient.GetGroupChart, effectiveSettings.GetGroupChartSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callListGroupCharts = clientHelper.BuildApiCall<ListGroupChartsRequest, ListGroupChartsResponse>(
                GrpcClient.ListGroupChartsAsync, GrpcClient.ListGroupCharts, effectiveSettings.ListGroupChartsSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callListGroupConfigs = clientHelper.BuildApiCall<ListGroupConfigsRequest, ListGroupConfigsResponse>(
                GrpcClient.ListGroupConfigsAsync, GrpcClient.ListGroupConfigs, effectiveSettings.ListGroupConfigsSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callUpdateGroupConfigs = clientHelper.BuildApiCall<UpdateGroupConfigsRequest, UpdateGroupConfigsResponse>(
                GrpcClient.UpdateGroupConfigsAsync, GrpcClient.UpdateGroupConfigs, effectiveSettings.UpdateGroupConfigsSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callDisableAllEnabledGroupsOfConfig = clientHelper.BuildApiCall<DisableAllEnabledGroupsOfConfigRequest, DisableAllEnabledGroupsOfConfigResponse>(
                GrpcClient.DisableAllEnabledGroupsOfConfigAsync, GrpcClient.DisableAllEnabledGroupsOfConfig, effectiveSettings.DisableAllEnabledGroupsOfConfigSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callListConfigPackages = clientHelper.BuildApiCall<ListConfigPackagesRequest, ListConfigPackagesResponse>(
                GrpcClient.ListConfigPackagesAsync, GrpcClient.ListConfigPackages, effectiveSettings.ListConfigPackagesSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callUpdateConfigPackages = clientHelper.BuildApiCall<UpdateConfigPackagesRequest, UpdateConfigPackagesResponse>(
                GrpcClient.UpdateConfigPackagesAsync, GrpcClient.UpdateConfigPackages, effectiveSettings.UpdateConfigPackagesSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            _callListConfigsUsingPackage = clientHelper.BuildApiCall<ListConfigsUsingPackageRequest, ListConfigsUsingPackageResponse>(
                GrpcClient.ListConfigsUsingPackageAsync, GrpcClient.ListConfigsUsingPackage, effectiveSettings.ListConfigsUsingPackageSettings)
                .WithCallSettingsOverlay(request => gaxgrpc::CallSettings.FromHeader("x-goog-request-params", $"name={request.Name}"));
            Modify_ApiCall(ref _callGetDeployment);
            Modify_GetDeploymentApiCall(ref _callGetDeployment);
            Modify_ApiCall(ref _callListDeployments);
            Modify_ListDeploymentsApiCall(ref _callListDeployments);
            Modify_ApiCall(ref _callUpdateDeployment);
            Modify_UpdateDeploymentApiCall(ref _callUpdateDeployment);
            Modify_ApiCall(ref _callGetPackage);
            Modify_GetPackageApiCall(ref _callGetPackage);
            Modify_ApiCall(ref _callListPackages);
            Modify_ListPackagesApiCall(ref _callListPackages);
            Modify_ApiCall(ref _callDeletePackage);
            Modify_DeletePackageApiCall(ref _callDeletePackage);
            Modify_ApiCall(ref _callUpdatePackage);
            Modify_UpdatePackageApiCall(ref _callUpdatePackage);
            Modify_ApiCall(ref _callCreateConfig);
            Modify_CreateConfigApiCall(ref _callCreateConfig);
            Modify_ApiCall(ref _callGetConfig);
            Modify_GetConfigApiCall(ref _callGetConfig);
            Modify_ApiCall(ref _callListConfigs);
            Modify_ListConfigsApiCall(ref _callListConfigs);
            Modify_ApiCall(ref _callDeleteConfig);
            Modify_DeleteConfigApiCall(ref _callDeleteConfig);
            Modify_ApiCall(ref _callUpdateConfig);
            Modify_UpdateConfigApiCall(ref _callUpdateConfig);
            Modify_ApiCall(ref _callCreateGroup);
            Modify_CreateGroupApiCall(ref _callCreateGroup);
            Modify_ApiCall(ref _callGetGroup);
            Modify_GetGroupApiCall(ref _callGetGroup);
            Modify_ApiCall(ref _callListGroups);
            Modify_ListGroupsApiCall(ref _callListGroups);
            Modify_ApiCall(ref _callDeleteGroup);
            Modify_DeleteGroupApiCall(ref _callDeleteGroup);
            Modify_ApiCall(ref _callUpdateGroup);
            Modify_UpdateGroupApiCall(ref _callUpdateGroup);
            Modify_ApiCall(ref _callDisableGroups);
            Modify_DisableGroupsApiCall(ref _callDisableGroups);
            Modify_ApiCall(ref _callEnableGroups);
            Modify_EnableGroupsApiCall(ref _callEnableGroups);
            Modify_ApiCall(ref _callCreateGroupMember);
            Modify_CreateGroupMemberApiCall(ref _callCreateGroupMember);
            Modify_ApiCall(ref _callCreateGroupMembers);
            Modify_CreateGroupMembersApiCall(ref _callCreateGroupMembers);
            Modify_ApiCall(ref _callGetGroupMember);
            Modify_GetGroupMemberApiCall(ref _callGetGroupMember);
            Modify_ApiCall(ref _callListGroupMembers);
            Modify_ListGroupMembersApiCall(ref _callListGroupMembers);
            Modify_ApiCall(ref _callDeleteGroupMember);
            Modify_DeleteGroupMemberApiCall(ref _callDeleteGroupMember);
            Modify_ApiCall(ref _callDeleteGroupMembers);
            Modify_DeleteGroupMembersApiCall(ref _callDeleteGroupMembers);
            Modify_ApiCall(ref _callGetGroupChart);
            Modify_GetGroupChartApiCall(ref _callGetGroupChart);
            Modify_ApiCall(ref _callListGroupCharts);
            Modify_ListGroupChartsApiCall(ref _callListGroupCharts);
            Modify_ApiCall(ref _callListGroupConfigs);
            Modify_ListGroupConfigsApiCall(ref _callListGroupConfigs);
            Modify_ApiCall(ref _callUpdateGroupConfigs);
            Modify_UpdateGroupConfigsApiCall(ref _callUpdateGroupConfigs);
            Modify_ApiCall(ref _callDisableAllEnabledGroupsOfConfig);
            Modify_DisableAllEnabledGroupsOfConfigApiCall(ref _callDisableAllEnabledGroupsOfConfig);
            Modify_ApiCall(ref _callListConfigPackages);
            Modify_ListConfigPackagesApiCall(ref _callListConfigPackages);
            Modify_ApiCall(ref _callUpdateConfigPackages);
            Modify_UpdateConfigPackagesApiCall(ref _callUpdateConfigPackages);
            Modify_ApiCall(ref _callListConfigsUsingPackage);
            Modify_ListConfigsUsingPackageApiCall(ref _callListConfigsUsingPackage);
            OnConstruction(grpcClient, effectiveSettings, clientHelper);
        }

        // Partial methods are named to (mostly) ensure there cannot be conflicts with RPC method names.

        // Partial methods called for every ApiCall on construction.
        // Allows modification of all the underlying ApiCall objects.
        partial void Modify_ApiCall<TRequest, TResponse>(ref gaxgrpc::ApiCall<TRequest, TResponse> call)
            where TRequest : class, pb::IMessage<TRequest>
            where TResponse : class, pb::IMessage<TResponse>;

        // Partial methods called for each ApiCall on construction.
        // Allows per-RPC-method modification of the underlying ApiCall object.
        partial void Modify_GetDeploymentApiCall(ref gaxgrpc::ApiCall<GetDeploymentRequest, Deployment> call);
        partial void Modify_ListDeploymentsApiCall(ref gaxgrpc::ApiCall<ListDeploymentsRequest, ListDeploymentsResponse> call);
        partial void Modify_UpdateDeploymentApiCall(ref gaxgrpc::ApiCall<UpdateDeploymentRequest, Deployment> call);
        partial void Modify_GetPackageApiCall(ref gaxgrpc::ApiCall<GetPackageRequest, Package> call);
        partial void Modify_ListPackagesApiCall(ref gaxgrpc::ApiCall<ListPackagesRequest, ListPackagesResponse> call);
        partial void Modify_DeletePackageApiCall(ref gaxgrpc::ApiCall<DeletePackageRequest, DeletePackageResponse> call);
        partial void Modify_UpdatePackageApiCall(ref gaxgrpc::ApiCall<UpdatePackageRequest, Package> call);
        partial void Modify_CreateConfigApiCall(ref gaxgrpc::ApiCall<CreateConfigRequest, Config> call);
        partial void Modify_GetConfigApiCall(ref gaxgrpc::ApiCall<GetConfigRequest, Config> call);
        partial void Modify_ListConfigsApiCall(ref gaxgrpc::ApiCall<ListConfigsRequest, ListConfigsResponse> call);
        partial void Modify_DeleteConfigApiCall(ref gaxgrpc::ApiCall<DeleteConfigRequest, DeleteConfigResponse> call);
        partial void Modify_UpdateConfigApiCall(ref gaxgrpc::ApiCall<UpdateConfigRequest, Config> call);
        partial void Modify_CreateGroupApiCall(ref gaxgrpc::ApiCall<CreateGroupRequest, Group> call);
        partial void Modify_GetGroupApiCall(ref gaxgrpc::ApiCall<GetGroupRequest, Group> call);
        partial void Modify_ListGroupsApiCall(ref gaxgrpc::ApiCall<ListGroupsRequest, ListGroupsResponse> call);
        partial void Modify_DeleteGroupApiCall(ref gaxgrpc::ApiCall<DeleteGroupRequest, DeleteGroupResponse> call);
        partial void Modify_UpdateGroupApiCall(ref gaxgrpc::ApiCall<UpdateGroupRequest, Group> call);
        partial void Modify_DisableGroupsApiCall(ref gaxgrpc::ApiCall<DisableGroupsRequest, DisableGroupsResponse> call);
        partial void Modify_EnableGroupsApiCall(ref gaxgrpc::ApiCall<EnableGroupsRequest, EnableGroupsResponse> call);
        partial void Modify_CreateGroupMemberApiCall(ref gaxgrpc::ApiCall<CreateGroupMemberRequest, GroupMember> call);
        partial void Modify_CreateGroupMembersApiCall(ref gaxgrpc::ApiCall<CreateGroupMembersRequest, CreateGroupMembersResponse> call);
        partial void Modify_GetGroupMemberApiCall(ref gaxgrpc::ApiCall<GetGroupMemberRequest, GroupMember> call);
        partial void Modify_ListGroupMembersApiCall(ref gaxgrpc::ApiCall<ListGroupMembersRequest, ListGroupMembersResponse> call);
        partial void Modify_DeleteGroupMemberApiCall(ref gaxgrpc::ApiCall<DeleteGroupMemberRequest, DeleteGroupMemberResponse> call);
        partial void Modify_DeleteGroupMembersApiCall(ref gaxgrpc::ApiCall<DeleteGroupMembersRequest, DeleteGroupMembersResponse> call);
        partial void Modify_GetGroupChartApiCall(ref gaxgrpc::ApiCall<GetGroupChartRequest, Chart> call);
        partial void Modify_ListGroupChartsApiCall(ref gaxgrpc::ApiCall<ListGroupChartsRequest, ListGroupChartsResponse> call);
        partial void Modify_ListGroupConfigsApiCall(ref gaxgrpc::ApiCall<ListGroupConfigsRequest, ListGroupConfigsResponse> call);
        partial void Modify_UpdateGroupConfigsApiCall(ref gaxgrpc::ApiCall<UpdateGroupConfigsRequest, UpdateGroupConfigsResponse> call);
        partial void Modify_DisableAllEnabledGroupsOfConfigApiCall(ref gaxgrpc::ApiCall<DisableAllEnabledGroupsOfConfigRequest, DisableAllEnabledGroupsOfConfigResponse> call);
        partial void Modify_ListConfigPackagesApiCall(ref gaxgrpc::ApiCall<ListConfigPackagesRequest, ListConfigPackagesResponse> call);
        partial void Modify_UpdateConfigPackagesApiCall(ref gaxgrpc::ApiCall<UpdateConfigPackagesRequest, UpdateConfigPackagesResponse> call);
        partial void Modify_ListConfigsUsingPackageApiCall(ref gaxgrpc::ApiCall<ListConfigsUsingPackageRequest, ListConfigsUsingPackageResponse> call);
        partial void OnConstruction(OverTheAirService.OverTheAirServiceClient grpcClient, OverTheAirServiceSettings effectiveSettings, gaxgrpc::ClientHelper clientHelper);

        /// <summary>
        /// The underlying gRPC OverTheAirService client.
        /// </summary>
        public override OverTheAirService.OverTheAirServiceClient GrpcClient { get; }

        // Partial methods called on each request.
        // Allows per-RPC-call modification to the request and CallSettings objects,
        // before the underlying RPC is performed.
        partial void Modify_GetDeploymentRequest(ref GetDeploymentRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_ListDeploymentsRequest(ref ListDeploymentsRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_UpdateDeploymentRequest(ref UpdateDeploymentRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_GetPackageRequest(ref GetPackageRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_ListPackagesRequest(ref ListPackagesRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_DeletePackageRequest(ref DeletePackageRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_UpdatePackageRequest(ref UpdatePackageRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_CreateConfigRequest(ref CreateConfigRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_GetConfigRequest(ref GetConfigRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_ListConfigsRequest(ref ListConfigsRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_DeleteConfigRequest(ref DeleteConfigRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_UpdateConfigRequest(ref UpdateConfigRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_CreateGroupRequest(ref CreateGroupRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_GetGroupRequest(ref GetGroupRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_ListGroupsRequest(ref ListGroupsRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_DeleteGroupRequest(ref DeleteGroupRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_UpdateGroupRequest(ref UpdateGroupRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_DisableGroupsRequest(ref DisableGroupsRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_EnableGroupsRequest(ref EnableGroupsRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_CreateGroupMemberRequest(ref CreateGroupMemberRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_CreateGroupMembersRequest(ref CreateGroupMembersRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_GetGroupMemberRequest(ref GetGroupMemberRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_ListGroupMembersRequest(ref ListGroupMembersRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_DeleteGroupMemberRequest(ref DeleteGroupMemberRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_DeleteGroupMembersRequest(ref DeleteGroupMembersRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_GetGroupChartRequest(ref GetGroupChartRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_ListGroupChartsRequest(ref ListGroupChartsRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_ListGroupConfigsRequest(ref ListGroupConfigsRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_UpdateGroupConfigsRequest(ref UpdateGroupConfigsRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_DisableAllEnabledGroupsOfConfigRequest(ref DisableAllEnabledGroupsOfConfigRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_ListConfigPackagesRequest(ref ListConfigPackagesRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_UpdateConfigPackagesRequest(ref UpdateConfigPackagesRequest request, ref gaxgrpc::CallSettings settings);
        partial void Modify_ListConfigsUsingPackageRequest(ref ListConfigsUsingPackageRequest request, ref gaxgrpc::CallSettings settings);

        /// <summary>
        /// Gets a [Deployment][google.android.overtheair.v1.Deployment].
        /// Returns `NOT_FOUND` if the deployment does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<Deployment> GetDeploymentAsync(
            GetDeploymentRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_GetDeploymentRequest(ref request, ref callSettings);
            return _callGetDeployment.Async(request, callSettings);
        }

        /// <summary>
        /// Gets a [Deployment][google.android.overtheair.v1.Deployment].
        /// Returns `NOT_FOUND` if the deployment does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override Deployment GetDeployment(
            GetDeploymentRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_GetDeploymentRequest(ref request, ref callSettings);
            return _callGetDeployment.Sync(request, callSettings);
        }

        /// <summary>
        /// Lists [deployments][google.android.overtheair.v1.Deployment].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<ListDeploymentsResponse> ListDeploymentsAsync(
            ListDeploymentsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_ListDeploymentsRequest(ref request, ref callSettings);
            return _callListDeployments.Async(request, callSettings);
        }

        /// <summary>
        /// Lists [deployments][google.android.overtheair.v1.Deployment].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override ListDeploymentsResponse ListDeployments(
            ListDeploymentsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_ListDeploymentsRequest(ref request, ref callSettings);
            return _callListDeployments.Sync(request, callSettings);
        }

        /// <summary>
        /// Updates a [deployment][google.android.overtheair.v1.Deployment].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<Deployment> UpdateDeploymentAsync(
            UpdateDeploymentRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_UpdateDeploymentRequest(ref request, ref callSettings);
            return _callUpdateDeployment.Async(request, callSettings);
        }

        /// <summary>
        /// Updates a [deployment][google.android.overtheair.v1.Deployment].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override Deployment UpdateDeployment(
            UpdateDeploymentRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_UpdateDeploymentRequest(ref request, ref callSettings);
            return _callUpdateDeployment.Sync(request, callSettings);
        }

        /// <summary>
        /// Gets a [package][google.android.overtheair.v1.Package].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<Package> GetPackageAsync(
            GetPackageRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_GetPackageRequest(ref request, ref callSettings);
            return _callGetPackage.Async(request, callSettings);
        }

        /// <summary>
        /// Gets a [package][google.android.overtheair.v1.Package].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override Package GetPackage(
            GetPackageRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_GetPackageRequest(ref request, ref callSettings);
            return _callGetPackage.Sync(request, callSettings);
        }

        /// <summary>
        /// Lists [packages][google.android.overtheair.v1.Package].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<ListPackagesResponse> ListPackagesAsync(
            ListPackagesRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_ListPackagesRequest(ref request, ref callSettings);
            return _callListPackages.Async(request, callSettings);
        }

        /// <summary>
        /// Lists [packages][google.android.overtheair.v1.Package].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override ListPackagesResponse ListPackages(
            ListPackagesRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_ListPackagesRequest(ref request, ref callSettings);
            return _callListPackages.Sync(request, callSettings);
        }

        /// <summary>
        /// Deletes a [package][google.android.overtheair.v1.Package].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<DeletePackageResponse> DeletePackageAsync(
            DeletePackageRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_DeletePackageRequest(ref request, ref callSettings);
            return _callDeletePackage.Async(request, callSettings);
        }

        /// <summary>
        /// Deletes a [package][google.android.overtheair.v1.Package].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override DeletePackageResponse DeletePackage(
            DeletePackageRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_DeletePackageRequest(ref request, ref callSettings);
            return _callDeletePackage.Sync(request, callSettings);
        }

        /// <summary>
        /// Updates a [package][google.android.overtheair.v1.Package].
        /// Returns `INVALID_ARGUMENT` if any field other than title is modified.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<Package> UpdatePackageAsync(
            UpdatePackageRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_UpdatePackageRequest(ref request, ref callSettings);
            return _callUpdatePackage.Async(request, callSettings);
        }

        /// <summary>
        /// Updates a [package][google.android.overtheair.v1.Package].
        /// Returns `INVALID_ARGUMENT` if any field other than title is modified.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override Package UpdatePackage(
            UpdatePackageRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_UpdatePackageRequest(ref request, ref callSettings);
            return _callUpdatePackage.Sync(request, callSettings);
        }

        /// <summary>
        /// Creates a config, and returns the new
        /// [Config][google.android.overtheair.v1.Config].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<Config> CreateConfigAsync(
            CreateConfigRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_CreateConfigRequest(ref request, ref callSettings);
            return _callCreateConfig.Async(request, callSettings);
        }

        /// <summary>
        /// Creates a config, and returns the new
        /// [Config][google.android.overtheair.v1.Config].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override Config CreateConfig(
            CreateConfigRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_CreateConfigRequest(ref request, ref callSettings);
            return _callCreateConfig.Sync(request, callSettings);
        }

        /// <summary>
        /// Gets a [config][google.android.overtheair.v1.Config] view.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<Config> GetConfigAsync(
            GetConfigRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_GetConfigRequest(ref request, ref callSettings);
            return _callGetConfig.Async(request, callSettings);
        }

        /// <summary>
        /// Gets a [config][google.android.overtheair.v1.Config] view.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override Config GetConfig(
            GetConfigRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_GetConfigRequest(ref request, ref callSettings);
            return _callGetConfig.Sync(request, callSettings);
        }

        /// <summary>
        /// Lists [configs][google.android.overtheair.v1.Config] of a deployment.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<ListConfigsResponse> ListConfigsAsync(
            ListConfigsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_ListConfigsRequest(ref request, ref callSettings);
            return _callListConfigs.Async(request, callSettings);
        }

        /// <summary>
        /// Lists [configs][google.android.overtheair.v1.Config] of a deployment.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override ListConfigsResponse ListConfigs(
            ListConfigsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_ListConfigsRequest(ref request, ref callSettings);
            return _callListConfigs.Sync(request, callSettings);
        }

        /// <summary>
        /// Deletes a [config][google.android.overtheair.v1.Config].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<DeleteConfigResponse> DeleteConfigAsync(
            DeleteConfigRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_DeleteConfigRequest(ref request, ref callSettings);
            return _callDeleteConfig.Async(request, callSettings);
        }

        /// <summary>
        /// Deletes a [config][google.android.overtheair.v1.Config].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override DeleteConfigResponse DeleteConfig(
            DeleteConfigRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_DeleteConfigRequest(ref request, ref callSettings);
            return _callDeleteConfig.Sync(request, callSettings);
        }

        /// <summary>
        /// Updates a [config][google.android.overtheair.v1.Config].
        /// Returns `INVALID_ARGUMENT` if the name of the config is non-empty and does
        /// not equal the existing name.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<Config> UpdateConfigAsync(
            UpdateConfigRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_UpdateConfigRequest(ref request, ref callSettings);
            return _callUpdateConfig.Async(request, callSettings);
        }

        /// <summary>
        /// Updates a [config][google.android.overtheair.v1.Config].
        /// Returns `INVALID_ARGUMENT` if the name of the config is non-empty and does
        /// not equal the existing name.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override Config UpdateConfig(
            UpdateConfigRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_UpdateConfigRequest(ref request, ref callSettings);
            return _callUpdateConfig.Sync(request, callSettings);
        }

        /// <summary>
        /// Creates a group, and returns the new
        /// [Group][google.android.overtheair.v1.Group].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<Group> CreateGroupAsync(
            CreateGroupRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_CreateGroupRequest(ref request, ref callSettings);
            return _callCreateGroup.Async(request, callSettings);
        }

        /// <summary>
        /// Creates a group, and returns the new
        /// [Group][google.android.overtheair.v1.Group].
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override Group CreateGroup(
            CreateGroupRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_CreateGroupRequest(ref request, ref callSettings);
            return _callCreateGroup.Sync(request, callSettings);
        }

        /// <summary>
        /// Gets a [group][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the group does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<Group> GetGroupAsync(
            GetGroupRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_GetGroupRequest(ref request, ref callSettings);
            return _callGetGroup.Async(request, callSettings);
        }

        /// <summary>
        /// Gets a [group][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the group does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override Group GetGroup(
            GetGroupRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_GetGroupRequest(ref request, ref callSettings);
            return _callGetGroup.Sync(request, callSettings);
        }

        /// <summary>
        /// Lists [groups][google.android.overtheair.v1.Group] of a deployment.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<ListGroupsResponse> ListGroupsAsync(
            ListGroupsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_ListGroupsRequest(ref request, ref callSettings);
            return _callListGroups.Async(request, callSettings);
        }

        /// <summary>
        /// Lists [groups][google.android.overtheair.v1.Group] of a deployment.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override ListGroupsResponse ListGroups(
            ListGroupsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_ListGroupsRequest(ref request, ref callSettings);
            return _callListGroups.Sync(request, callSettings);
        }

        /// <summary>
        /// Deletes a [group][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the group does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<DeleteGroupResponse> DeleteGroupAsync(
            DeleteGroupRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_DeleteGroupRequest(ref request, ref callSettings);
            return _callDeleteGroup.Async(request, callSettings);
        }

        /// <summary>
        /// Deletes a [group][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the group does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override DeleteGroupResponse DeleteGroup(
            DeleteGroupRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_DeleteGroupRequest(ref request, ref callSettings);
            return _callDeleteGroup.Sync(request, callSettings);
        }

        /// <summary>
        /// Updates a [group][google.android.overtheair.v1.Group].
        /// Returns INVALID_ARGUMENT if the name of the group is non-empty and does
        /// not equal the existing name.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<Group> UpdateGroupAsync(
            UpdateGroupRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_UpdateGroupRequest(ref request, ref callSettings);
            return _callUpdateGroup.Async(request, callSettings);
        }

        /// <summary>
        /// Updates a [group][google.android.overtheair.v1.Group].
        /// Returns INVALID_ARGUMENT if the name of the group is non-empty and does
        /// not equal the existing name.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override Group UpdateGroup(
            UpdateGroupRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_UpdateGroupRequest(ref request, ref callSettings);
            return _callUpdateGroup.Sync(request, callSettings);
        }

        /// <summary>
        /// Disables the defined [groups][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<DisableGroupsResponse> DisableGroupsAsync(
            DisableGroupsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_DisableGroupsRequest(ref request, ref callSettings);
            return _callDisableGroups.Async(request, callSettings);
        }

        /// <summary>
        /// Disables the defined [groups][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override DisableGroupsResponse DisableGroups(
            DisableGroupsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_DisableGroupsRequest(ref request, ref callSettings);
            return _callDisableGroups.Sync(request, callSettings);
        }

        /// <summary>
        /// Enables the defined [groups][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<EnableGroupsResponse> EnableGroupsAsync(
            EnableGroupsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_EnableGroupsRequest(ref request, ref callSettings);
            return _callEnableGroups.Async(request, callSettings);
        }

        /// <summary>
        /// Enables the defined [groups][google.android.overtheair.v1.Group].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override EnableGroupsResponse EnableGroups(
            EnableGroupsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_EnableGroupsRequest(ref request, ref callSettings);
            return _callEnableGroups.Sync(request, callSettings);
        }

        /// <summary>
        /// Creates a group member and returns the new
        /// [GroupMember][google.android.overtheair.v1.GroupMember]. If the device is
        /// already under other groups, it will be removed from those groups and added
        /// to the group that's specified in the request.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<GroupMember> CreateGroupMemberAsync(
            CreateGroupMemberRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_CreateGroupMemberRequest(ref request, ref callSettings);
            return _callCreateGroupMember.Async(request, callSettings);
        }

        /// <summary>
        /// Creates a group member and returns the new
        /// [GroupMember][google.android.overtheair.v1.GroupMember]. If the device is
        /// already under other groups, it will be removed from those groups and added
        /// to the group that's specified in the request.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override GroupMember CreateGroupMember(
            CreateGroupMemberRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_CreateGroupMemberRequest(ref request, ref callSettings);
            return _callCreateGroupMember.Sync(request, callSettings);
        }

        /// <summary>
        /// Creates group members in a specific group.  If any device is in other
        /// groups, it will be removed from those groups and added to the group that's
        /// specified in the request.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<CreateGroupMembersResponse> CreateGroupMembersAsync(
            CreateGroupMembersRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_CreateGroupMembersRequest(ref request, ref callSettings);
            return _callCreateGroupMembers.Async(request, callSettings);
        }

        /// <summary>
        /// Creates group members in a specific group.  If any device is in other
        /// groups, it will be removed from those groups and added to the group that's
        /// specified in the request.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override CreateGroupMembersResponse CreateGroupMembers(
            CreateGroupMembersRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_CreateGroupMembersRequest(ref request, ref callSettings);
            return _callCreateGroupMembers.Sync(request, callSettings);
        }

        /// <summary>
        /// Gets a [group member][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<GroupMember> GetGroupMemberAsync(
            GetGroupMemberRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_GetGroupMemberRequest(ref request, ref callSettings);
            return _callGetGroupMember.Async(request, callSettings);
        }

        /// <summary>
        /// Gets a [group member][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override GroupMember GetGroupMember(
            GetGroupMemberRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_GetGroupMemberRequest(ref request, ref callSettings);
            return _callGetGroupMember.Sync(request, callSettings);
        }

        /// <summary>
        /// Lists [group members][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<ListGroupMembersResponse> ListGroupMembersAsync(
            ListGroupMembersRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_ListGroupMembersRequest(ref request, ref callSettings);
            return _callListGroupMembers.Async(request, callSettings);
        }

        /// <summary>
        /// Lists [group members][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override ListGroupMembersResponse ListGroupMembers(
            ListGroupMembersRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_ListGroupMembersRequest(ref request, ref callSettings);
            return _callListGroupMembers.Sync(request, callSettings);
        }

        /// <summary>
        /// Deletes a [group member][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<DeleteGroupMemberResponse> DeleteGroupMemberAsync(
            DeleteGroupMemberRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_DeleteGroupMemberRequest(ref request, ref callSettings);
            return _callDeleteGroupMember.Async(request, callSettings);
        }

        /// <summary>
        /// Deletes a [group member][google.android.overtheair.v1.GroupMember].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override DeleteGroupMemberResponse DeleteGroupMember(
            DeleteGroupMemberRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_DeleteGroupMemberRequest(ref request, ref callSettings);
            return _callDeleteGroupMember.Sync(request, callSettings);
        }

        /// <summary>
        /// Deletes group members in a group.  If any member does not it exist, it
        /// will be ignored.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<DeleteGroupMembersResponse> DeleteGroupMembersAsync(
            DeleteGroupMembersRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_DeleteGroupMembersRequest(ref request, ref callSettings);
            return _callDeleteGroupMembers.Async(request, callSettings);
        }

        /// <summary>
        /// Deletes group members in a group.  If any member does not it exist, it
        /// will be ignored.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override DeleteGroupMembersResponse DeleteGroupMembers(
            DeleteGroupMembersRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_DeleteGroupMembersRequest(ref request, ref callSettings);
            return _callDeleteGroupMembers.Sync(request, callSettings);
        }

        /// <summary>
        /// Gets a [group chart][google.android.overtheair.v1.Chart].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<Chart> GetGroupChartAsync(
            GetGroupChartRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_GetGroupChartRequest(ref request, ref callSettings);
            return _callGetGroupChart.Async(request, callSettings);
        }

        /// <summary>
        /// Gets a [group chart][google.android.overtheair.v1.Chart].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override Chart GetGroupChart(
            GetGroupChartRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_GetGroupChartRequest(ref request, ref callSettings);
            return _callGetGroupChart.Sync(request, callSettings);
        }

        /// <summary>
        /// Lists [group charts][google.android.overtheair.v1.Chart].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<ListGroupChartsResponse> ListGroupChartsAsync(
            ListGroupChartsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_ListGroupChartsRequest(ref request, ref callSettings);
            return _callListGroupCharts.Async(request, callSettings);
        }

        /// <summary>
        /// Lists [group charts][google.android.overtheair.v1.Chart].
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override ListGroupChartsResponse ListGroupCharts(
            ListGroupChartsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_ListGroupChartsRequest(ref request, ref callSettings);
            return _callListGroupCharts.Sync(request, callSettings);
        }

        /// <summary>
        /// Lists configs of the group. Returns `NOT_FOUND` if the matching path
        /// does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<ListGroupConfigsResponse> ListGroupConfigsAsync(
            ListGroupConfigsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_ListGroupConfigsRequest(ref request, ref callSettings);
            return _callListGroupConfigs.Async(request, callSettings);
        }

        /// <summary>
        /// Lists configs of the group. Returns `NOT_FOUND` if the matching path
        /// does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override ListGroupConfigsResponse ListGroupConfigs(
            ListGroupConfigsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_ListGroupConfigsRequest(ref request, ref callSettings);
            return _callListGroupConfigs.Sync(request, callSettings);
        }

        /// <summary>
        /// Update the configs under a group. Returns `NOT_FOUND` if the matching group
        /// or config does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<UpdateGroupConfigsResponse> UpdateGroupConfigsAsync(
            UpdateGroupConfigsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_UpdateGroupConfigsRequest(ref request, ref callSettings);
            return _callUpdateGroupConfigs.Async(request, callSettings);
        }

        /// <summary>
        /// Update the configs under a group. Returns `NOT_FOUND` if the matching group
        /// or config does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override UpdateGroupConfigsResponse UpdateGroupConfigs(
            UpdateGroupConfigsRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_UpdateGroupConfigsRequest(ref request, ref callSettings);
            return _callUpdateGroupConfigs.Sync(request, callSettings);
        }

        /// <summary>
        /// Disables all enabled groups that have the specified config.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<DisableAllEnabledGroupsOfConfigResponse> DisableAllEnabledGroupsOfConfigAsync(
            DisableAllEnabledGroupsOfConfigRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_DisableAllEnabledGroupsOfConfigRequest(ref request, ref callSettings);
            return _callDisableAllEnabledGroupsOfConfig.Async(request, callSettings);
        }

        /// <summary>
        /// Disables all enabled groups that have the specified config.
        /// Returns `NOT_FOUND` if the matching path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override DisableAllEnabledGroupsOfConfigResponse DisableAllEnabledGroupsOfConfig(
            DisableAllEnabledGroupsOfConfigRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_DisableAllEnabledGroupsOfConfigRequest(ref request, ref callSettings);
            return _callDisableAllEnabledGroupsOfConfig.Sync(request, callSettings);
        }

        /// <summary>
        /// Lists packages of the config. Returns `NOT_FOUND` if the matching path does
        /// not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<ListConfigPackagesResponse> ListConfigPackagesAsync(
            ListConfigPackagesRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_ListConfigPackagesRequest(ref request, ref callSettings);
            return _callListConfigPackages.Async(request, callSettings);
        }

        /// <summary>
        /// Lists packages of the config. Returns `NOT_FOUND` if the matching path does
        /// not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override ListConfigPackagesResponse ListConfigPackages(
            ListConfigPackagesRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_ListConfigPackagesRequest(ref request, ref callSettings);
            return _callListConfigPackages.Sync(request, callSettings);
        }

        /// <summary>
        /// Update the packages under the config. Returns `NOT_FOUND` if the matching
        /// path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<UpdateConfigPackagesResponse> UpdateConfigPackagesAsync(
            UpdateConfigPackagesRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_UpdateConfigPackagesRequest(ref request, ref callSettings);
            return _callUpdateConfigPackages.Async(request, callSettings);
        }

        /// <summary>
        /// Update the packages under the config. Returns `NOT_FOUND` if the matching
        /// path does not exist.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override UpdateConfigPackagesResponse UpdateConfigPackages(
            UpdateConfigPackagesRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_UpdateConfigPackagesRequest(ref request, ref callSettings);
            return _callUpdateConfigPackages.Sync(request, callSettings);
        }

        /// <summary>
        /// Lists all the configs that use the specified package.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// A Task containing the RPC response.
        /// </returns>
        public override stt::Task<ListConfigsUsingPackageResponse> ListConfigsUsingPackageAsync(
            ListConfigsUsingPackageRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_ListConfigsUsingPackageRequest(ref request, ref callSettings);
            return _callListConfigsUsingPackage.Async(request, callSettings);
        }

        /// <summary>
        /// Lists all the configs that use the specified package.
        /// </summary>
        /// <param name="request">
        /// The request object containing all of the parameters for the API call.
        /// </param>
        /// <param name="callSettings">
        /// If not null, applies overrides to this RPC call.
        /// </param>
        /// <returns>
        /// The RPC response.
        /// </returns>
        public override ListConfigsUsingPackageResponse ListConfigsUsingPackage(
            ListConfigsUsingPackageRequest request,
            gaxgrpc::CallSettings callSettings = null)
        {
            Modify_ListConfigsUsingPackageRequest(ref request, ref callSettings);
            return _callListConfigsUsingPackage.Sync(request, callSettings);
        }

    }

    // Partial classes to enable page-streaming


}
